# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .rcw_domain_user_model import RcwDomainUserModel
from .rcw_role_enum import RcwRoleEnum
from .rcw_invitee_type_enum import RcwInviteeTypeEnum


@JsonMap(
    {
        "first_name": "firstName",
        "last_name": "lastName",
        "job_title": "jobTitle",
        "linked_user": "linkedUser",
        "type_": "type",
        "send_invite": "sendInvite",
    }
)
class AddInviteeRequest(BaseModel):
    """AddInviteeRequest

    :param first_name: First (given) name, defaults to None
    :type first_name: str, optional
    :param last_name: Last (family) name, defaults to None
    :type last_name: str, optional
    :param email: User's contact email, defaults to None
    :type email: str, optional
    :param job_title: Job title, defaults to None
    :type job_title: str, optional
    :param linked_user: linked_user, defaults to None
    :type linked_user: RcwDomainUserModel, optional
    :param role: The role of the webinar session participant/invitee.<br>See also: [Understanding Webinar Roles](https://support.ringcentral.com/webinar/getting-started/understanding-ringcentral-webinar-roles.html)<br>
    :type role: RcwRoleEnum
    :param type_: The type of the webinar invitee, defaults to None
    :type type_: RcwInviteeTypeEnum, optional
    :param send_invite: Indicates if invite/cancellation emails have to be sent to this invitee.<br>For "Host" it cannot be set to false.<br>If it is true it can't be changed back to false.<br>, defaults to None
    :type send_invite: bool, optional
    """

    def __init__(
        self,
        role: RcwRoleEnum,
        first_name: str = None,
        last_name: str = None,
        email: str = None,
        job_title: str = None,
        linked_user: RcwDomainUserModel = None,
        type_: RcwInviteeTypeEnum = None,
        send_invite: bool = None,
    ):
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if email is not None:
            self.email = email
        if job_title is not None:
            self.job_title = job_title
        if linked_user is not None:
            self.linked_user = self._define_object(linked_user, RcwDomainUserModel)
        self.role = self._enum_matching(role, RcwRoleEnum.list(), "role")
        if type_ is not None:
            self.type_ = self._enum_matching(type_, RcwInviteeTypeEnum.list(), "type_")
        if send_invite is not None:
            self.send_invite = send_invite
