# This file was generated by liblab | https://liblab.com/

from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "bulk_item_successful": "bulkItemSuccessful",
        "bulk_item_errors": "bulkItemErrors",
        "id_": "id",
        "phone_number": "phoneNumber",
    }
)
class AddPhoneNumbersResponseItem(BaseModel):
    """AddPhoneNumbersResponseItem

    :param bulk_item_successful: Indicates if this item was processed successfully during bulk operation.<br>If false, `bulkItemErrors` attribute contains the list of errors<br>
    :type bulk_item_successful: bool
    :param bulk_item_errors: The list of errors occurred during processing of particular item of bulk operation.<br>Returned only if `bulkItemSuccessful` is false<br>, defaults to None
    :type bulk_item_errors: List[dict], optional
    :param id_: Internal unique identifier of a phone number, defaults to None
    :type id_: str, optional
    :param phone_number: Phone number in e.164 format (with '+' prefix)
    :type phone_number: str
    """

    def __init__(
        self,
        bulk_item_successful: bool,
        phone_number: str,
        bulk_item_errors: List[dict] = None,
        id_: str = None,
    ):
        self.bulk_item_successful = bulk_item_successful
        if bulk_item_errors is not None:
            self.bulk_item_errors = bulk_item_errors
        if id_ is not None:
            self.id_ = self._pattern_matching(id_, "^[1-9]\d{1,14}$", "id_")
        self.phone_number = self._pattern_matching(
            phone_number, "^\+[1-9]\d{1,14}$", "phone_number"
        )
