# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "error_code": "errorCode",
        "parameter_name": "parameterName",
        "parameter_value": "parameterValue",
    }
)
class ApiErrorWithParameter(BaseModel):
    """ApiErrorWithParameter

    :param error_code: Logical error code (typically, 3 letters followed with number, dash separated)
    :type error_code: str
    :param message: User-friendly error message
    :type message: str
    :param parameter_name: The name of the API parameter/attribute which caused the error, defaults to None
    :type parameter_name: str, optional
    :param parameter_value: The value of the API parameter/attribute which caused the error, defaults to None
    :type parameter_value: str, optional
    """

    def __init__(
        self,
        error_code: str,
        message: str,
        parameter_name: str = None,
        parameter_value: str = None,
    ):
        self.error_code = error_code
        self.message = message
        if parameter_name is not None:
            self.parameter_name = parameter_name
        if parameter_value is not None:
            self.parameter_value = parameter_value
