# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .api_version_info import ApiVersionInfo


@JsonMap(
    {
        "api_versions": "apiVersions",
        "server_version": "serverVersion",
        "server_revision": "serverRevision",
    }
)
class ApiVersionsList(BaseModel):
    """ApiVersionsList

    :param uri: Canonical URI of the API version, defaults to None
    :type uri: str, optional
    :param api_versions: Full API version information: uri, number, release date, defaults to None
    :type api_versions: List[ApiVersionInfo], optional
    :param server_version: Server version, defaults to None
    :type server_version: str, optional
    :param server_revision: Server revision, defaults to None
    :type server_revision: str, optional
    """

    def __init__(
        self,
        uri: str = None,
        api_versions: List[ApiVersionInfo] = None,
        server_version: str = None,
        server_revision: str = None,
    ):
        if uri is not None:
            self.uri = uri
        if api_versions is not None:
            self.api_versions = self._define_list(api_versions, ApiVersionInfo)
        if server_version is not None:
            self.server_version = server_version
        if server_revision is not None:
            self.server_revision = server_revision
