# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "outbound_call_tones": "outboundCallTones",
        "outbound_call_announcement": "outboundCallAnnouncement",
        "allow_mute": "allowMute",
        "extension_count": "extensionCount",
        "retention_period": "retentionPeriod",
        "max_number_limit": "maxNumberLimit",
    }
)
class AutomaticRecordingResource(BaseModel):
    """AutomaticRecordingResource

    :param enabled: Flag for controlling Automatic Call Recording settings, defaults to None
    :type enabled: bool, optional
    :param outbound_call_tones: Flag for controlling 'Play Call Recording Announcement for Outbound Calls' settings, defaults to None
    :type outbound_call_tones: bool, optional
    :param outbound_call_announcement: Flag for controlling 'Play periodic tones for outbound calls' settings, defaults to None
    :type outbound_call_announcement: bool, optional
    :param allow_mute: Flag for controlling 'Allow mute in auto call recording' settings, defaults to None
    :type allow_mute: bool, optional
    :param extension_count: Total amount of extension that are used in call recordings, defaults to None
    :type extension_count: int, optional
    :param retention_period: Retention period of a call recording, the default value is 90 days, defaults to None
    :type retention_period: int, optional
    :param max_number_limit: Maximum number of automatic call recordings per account, the default value is 100 000, defaults to None
    :type max_number_limit: int, optional
    """

    def __init__(
        self,
        enabled: bool = None,
        outbound_call_tones: bool = None,
        outbound_call_announcement: bool = None,
        allow_mute: bool = None,
        extension_count: int = None,
        retention_period: int = None,
        max_number_limit: int = None,
    ):
        if enabled is not None:
            self.enabled = enabled
        if outbound_call_tones is not None:
            self.outbound_call_tones = outbound_call_tones
        if outbound_call_announcement is not None:
            self.outbound_call_announcement = outbound_call_announcement
        if allow_mute is not None:
            self.allow_mute = allow_mute
        if extension_count is not None:
            self.extension_count = extension_count
        if retention_period is not None:
            self.retention_period = retention_period
        if max_number_limit is not None:
            self.max_number_limit = max_number_limit
