# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"cost_included": "costIncluded", "cost_purchased": "costPurchased"})
class BillingInfo(BaseModel):
    """Billing information related to the call. Returned for 'Detailed' view only

    :param cost_included: Cost per minute, paid and already included in your RingCentral service plan.<br>For example International Calls<br>, defaults to None
    :type cost_included: float, optional
    :param cost_purchased: Cost per minute, paid and not included in your RingCentral service plan, defaults to None
    :type cost_purchased: float, optional
    """

    def __init__(self, cost_included: float = None, cost_purchased: float = None):
        if cost_included is not None:
            self.cost_included = cost_included
        if cost_purchased is not None:
            self.cost_purchased = cost_purchased
