# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .bulk_operation_extension_reference import BulkOperationExtensionReference


@JsonMap({"keep_assets_in_inventory": "keepAssetsInInventory"})
class BulkDeleteUsersRequest(BaseModel):
    """BulkDeleteUsersRequest

    :param keep_assets_in_inventory: Indicates that the freed users' assets (phone numbers and devices) should be moved<br>to account inventory rather than deleted. If set to `true`, the phone numbers and devices<br>assigned to deleted extensions will be kept in the account's inventory. If set to `false`,<br>these assets will be deleted from the account and returned to either the partner's phone<br>numbers or RingCentral's phone number pool<br>, defaults to None
    :type keep_assets_in_inventory: bool, optional
    :param records: records
    :type records: List[BulkOperationExtensionReference]
    """

    def __init__(
        self,
        records: List[BulkOperationExtensionReference],
        keep_assets_in_inventory: bool = None,
    ):
        if keep_assets_in_inventory is not None:
            self.keep_assets_in_inventory = keep_assets_in_inventory
        self.records = self._define_list(records, BulkOperationExtensionReference)
