# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


class BulkTaskInfoStatus(Enum):
    """An enumeration representing different categories.

    :cvar ACCEPTED: "Accepted"
    :vartype ACCEPTED: str
    :cvar FAILED: "Failed"
    :vartype FAILED: str
    """

    ACCEPTED = "Accepted"
    FAILED = "Failed"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, BulkTaskInfoStatus._member_map_.values()))


@JsonMap(
    {
        "id_": "id",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class BulkTaskInfo(BaseModel):
    """BulkTaskInfo

    :param id_: Internal identifier of a task for multiple switches creation, defaults to None
    :type id_: str, optional
    :param status: Status of a task, defaults to None
    :type status: BulkTaskInfoStatus, optional
    :param creation_time: Task creation time, defaults to None
    :type creation_time: str, optional
    :param last_modified_time: Time of the task latest modification, defaults to None
    :type last_modified_time: str, optional
    """

    def __init__(
        self,
        id_: str = None,
        status: BulkTaskInfoStatus = None,
        creation_time: str = None,
        last_modified_time: str = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if status is not None:
            self.status = self._enum_matching(
                status, BulkTaskInfoStatus.list(), "status"
            )
        if creation_time is not None:
            self.creation_time = creation_time
        if last_modified_time is not None:
            self.last_modified_time = last_modified_time
