# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .call_log_sync_type_enum import CallLogSyncTypeEnum


@JsonMap({"sync_type": "syncType", "sync_token": "syncToken", "sync_time": "syncTime"})
class CallLogSyncInfo(BaseModel):
    """CallLogSyncInfo

    :param sync_type: Type of call log synchronization request: full or incremental sync
    :type sync_type: CallLogSyncTypeEnum
    :param sync_token: Synchronization token
    :type sync_token: str
    :param sync_time: Time of the last synchronization in (ISO 8601)[https://en.wikipedia.org/wiki/ISO_8601] format including timezone, for example *2016-03-10T18:07:52.534Z*
    :type sync_time: str
    """

    def __init__(self, sync_type: CallLogSyncTypeEnum, sync_token: str, sync_time: str):
        self.sync_type = self._enum_matching(
            sync_type, CallLogSyncTypeEnum.list(), "sync_type"
        )
        self.sync_token = sync_token
        self.sync_time = sync_time
