# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "sla_goal": "slaGoal",
        "sla_threshold_seconds": "slaThresholdSeconds",
        "include_abandoned_calls": "includeAbandonedCalls",
        "abandoned_threshold_seconds": "abandonedThresholdSeconds",
    }
)
class CallQueueExtensionInfo(BaseModel):
    """For Call Queue extension type only. Please note that legacy
    'Department' extension type corresponds to 'Call Queue' extensions
    in modern RingCentral product terminology


    :param sla_goal: Target percentage of calls that must be answered by agents<br>within the service level time threshold<br>, defaults to None
    :type sla_goal: int, optional
    :param sla_threshold_seconds: Period of time in seconds that is considered to be an acceptable<br>service level<br>, defaults to None
    :type sla_threshold_seconds: int, optional
    :param include_abandoned_calls: If `true` abandoned calls (hanged up prior to being served)<br>are included into service level calculation<br>, defaults to None
    :type include_abandoned_calls: bool, optional
    :param abandoned_threshold_seconds: Period of time in seconds specifying abandoned calls duration<br>- calls that are shorter will not be included into the calculation of<br>service level.; zero value means that abandoned calls of any duration<br>will be included into calculation<br>, defaults to None
    :type abandoned_threshold_seconds: int, optional
    """

    def __init__(
        self,
        sla_goal: int = None,
        sla_threshold_seconds: int = None,
        include_abandoned_calls: bool = None,
        abandoned_threshold_seconds: int = None,
    ):
        if sla_goal is not None:
            self.sla_goal = sla_goal
        if sla_threshold_seconds is not None:
            self.sla_threshold_seconds = sla_threshold_seconds
        if include_abandoned_calls is not None:
            self.include_abandoned_calls = include_abandoned_calls
        if abandoned_threshold_seconds is not None:
            self.abandoned_threshold_seconds = abandoned_threshold_seconds
