# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel
from .country_info_basic_model import CountryInfoBasicModel
from .extension_info import ExtensionInfo
from .platform_payment_type import PlatformPaymentType
from .temporary_number_info import TemporaryNumberInfo
from .contact_center_provider import ContactCenterProvider


class CompanyPhoneNumberInfoStatus(Enum):
    """An enumeration representing different categories.

    :cvar NORMAL: "Normal"
    :vartype NORMAL: str
    :cvar PENDING: "Pending"
    :vartype PENDING: str
    :cvar PORTEDIN: "PortedIn"
    :vartype PORTEDIN: str
    :cvar TEMPORARY: "Temporary"
    :vartype TEMPORARY: str
    """

    NORMAL = "Normal"
    PENDING = "Pending"
    PORTEDIN = "PortedIn"
    TEMPORARY = "Temporary"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, CompanyPhoneNumberInfoStatus._member_map_.values())
        )


class CompanyPhoneNumberInfoType(Enum):
    """An enumeration representing different categories.

    :cvar VOICEFAX: "VoiceFax"
    :vartype VOICEFAX: str
    :cvar FAXONLY: "FaxOnly"
    :vartype FAXONLY: str
    :cvar VOICEONLY: "VoiceOnly"
    :vartype VOICEONLY: str
    """

    VOICEFAX = "VoiceFax"
    FAXONLY = "FaxOnly"
    VOICEONLY = "VoiceOnly"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, CompanyPhoneNumberInfoType._member_map_.values())
        )


class CompanyPhoneNumberInfoUsageType(Enum):
    """An enumeration representing different categories.

    :cvar MAINCOMPANYNUMBER: "MainCompanyNumber"
    :vartype MAINCOMPANYNUMBER: str
    :cvar ADDITIONALCOMPANYNUMBER: "AdditionalCompanyNumber"
    :vartype ADDITIONALCOMPANYNUMBER: str
    :cvar COMPANYNUMBER: "CompanyNumber"
    :vartype COMPANYNUMBER: str
    :cvar DIRECTNUMBER: "DirectNumber"
    :vartype DIRECTNUMBER: str
    :cvar COMPANYFAXNUMBER: "CompanyFaxNumber"
    :vartype COMPANYFAXNUMBER: str
    :cvar FORWARDEDNUMBER: "ForwardedNumber"
    :vartype FORWARDEDNUMBER: str
    :cvar FORWARDEDCOMPANYNUMBER: "ForwardedCompanyNumber"
    :vartype FORWARDEDCOMPANYNUMBER: str
    :cvar CONTACTCENTERNUMBER: "ContactCenterNumber"
    :vartype CONTACTCENTERNUMBER: str
    :cvar CONFERENCINGNUMBER: "ConferencingNumber"
    :vartype CONFERENCINGNUMBER: str
    :cvar MEETINGSNUMBER: "MeetingsNumber"
    :vartype MEETINGSNUMBER: str
    :cvar NUMBERPOOL: "NumberPool"
    :vartype NUMBERPOOL: str
    :cvar BUSINESSMOBILENUMBER: "BusinessMobileNumber"
    :vartype BUSINESSMOBILENUMBER: str
    :cvar PARTNERBUSINESSMOBILENUMBER: "PartnerBusinessMobileNumber"
    :vartype PARTNERBUSINESSMOBILENUMBER: str
    :cvar INTEGRATIONNUMBER: "IntegrationNumber"
    :vartype INTEGRATIONNUMBER: str
    """

    MAINCOMPANYNUMBER = "MainCompanyNumber"
    ADDITIONALCOMPANYNUMBER = "AdditionalCompanyNumber"
    COMPANYNUMBER = "CompanyNumber"
    DIRECTNUMBER = "DirectNumber"
    COMPANYFAXNUMBER = "CompanyFaxNumber"
    FORWARDEDNUMBER = "ForwardedNumber"
    FORWARDEDCOMPANYNUMBER = "ForwardedCompanyNumber"
    CONTACTCENTERNUMBER = "ContactCenterNumber"
    CONFERENCINGNUMBER = "ConferencingNumber"
    MEETINGSNUMBER = "MeetingsNumber"
    NUMBERPOOL = "NumberPool"
    BUSINESSMOBILENUMBER = "BusinessMobileNumber"
    PARTNERBUSINESSMOBILENUMBER = "PartnerBusinessMobileNumber"
    INTEGRATIONNUMBER = "IntegrationNumber"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value, CompanyPhoneNumberInfoUsageType._member_map_.values()
            )
        )


@JsonMap(
    {
        "id_": "id",
        "payment_type": "paymentType",
        "phone_number": "phoneNumber",
        "type_": "type",
        "usage_type": "usageType",
        "temporary_number": "temporaryNumber",
        "contact_center_provider": "contactCenterProvider",
        "vanity_pattern": "vanityPattern",
    }
)
class CompanyPhoneNumberInfo(BaseModel):
    """CompanyPhoneNumberInfo

    :param uri: Link to a company phone number resource, defaults to None
    :type uri: str, optional
    :param id_: Internal identifier of a phone number, defaults to None
    :type id_: int, optional
    :param country: country, defaults to None
    :type country: CountryInfoBasicModel, optional
    :param extension: Information on the extension, to which the phone number is assigned.<br>Returned only for the request of Account phone number list<br>, defaults to None
    :type extension: ExtensionInfo, optional
    :param label: Custom user-defined name of a phone number, if any, defaults to None
    :type label: str, optional
    :param location: Location (City, State). Filled for local US numbers, defaults to None
    :type location: str, optional
    :param payment_type: Payment type. 'External' is returned for forwarded numbers<br>which are not terminated in the RingCentral phone system<br>, defaults to None
    :type payment_type: PlatformPaymentType, optional
    :param phone_number: Phone number, defaults to None
    :type phone_number: str, optional
    :param status: Status of a phone number. If the value is 'Normal', the phone<br>number is ready to be used. If the value is 'Pending' it is an<br>external number not yet ported to RingCentral.<br>, defaults to None
    :type status: CompanyPhoneNumberInfoStatus, optional
    :param type_: Phone number type, defaults to None
    :type type_: CompanyPhoneNumberInfoType, optional
    :param usage_type: Usage type of phone number. Usage type of phone number.<br>Numbers of 'NumberPool' type are not returned in phone number list<br>requests<br>, defaults to None
    :type usage_type: CompanyPhoneNumberInfoUsageType, optional
    :param temporary_number: Temporary phone number, if any. Returned for phone numbers in `Pending` porting status only<br>, defaults to None
    :type temporary_number: TemporaryNumberInfo, optional
    :param contact_center_provider: CCRN (Contact Center Routing Number) provider. If not specified<br>then the default value 'InContact/North America' is used, its ID is '1'<br>, defaults to None
    :type contact_center_provider: ContactCenterProvider, optional
    :param vanity_pattern: Vanity pattern for this number. Returned only when vanity search option is requested. Vanity pattern corresponds to request parameters `nxx` plus `line` or `numberPattern`, defaults to None
    :type vanity_pattern: str, optional
    :param primary: Specifies if a phone number is primary, i.e. displayed as 'main number' and called by default, defaults to None
    :type primary: bool, optional
    """

    def __init__(
        self,
        uri: str = None,
        id_: int = None,
        country: CountryInfoBasicModel = None,
        extension: ExtensionInfo = None,
        label: str = None,
        location: str = None,
        payment_type: PlatformPaymentType = None,
        phone_number: str = None,
        status: CompanyPhoneNumberInfoStatus = None,
        type_: CompanyPhoneNumberInfoType = None,
        usage_type: CompanyPhoneNumberInfoUsageType = None,
        temporary_number: TemporaryNumberInfo = None,
        contact_center_provider: ContactCenterProvider = None,
        vanity_pattern: str = None,
        primary: bool = None,
    ):
        if uri is not None:
            self.uri = uri
        if id_ is not None:
            self.id_ = id_
        if country is not None:
            self.country = self._define_object(country, CountryInfoBasicModel)
        if extension is not None:
            self.extension = self._define_object(extension, ExtensionInfo)
        if label is not None:
            self.label = label
        if location is not None:
            self.location = location
        if payment_type is not None:
            self.payment_type = self._enum_matching(
                payment_type, PlatformPaymentType.list(), "payment_type"
            )
        if phone_number is not None:
            self.phone_number = phone_number
        if status is not None:
            self.status = self._enum_matching(
                status, CompanyPhoneNumberInfoStatus.list(), "status"
            )
        if type_ is not None:
            self.type_ = self._enum_matching(
                type_, CompanyPhoneNumberInfoType.list(), "type_"
            )
        if usage_type is not None:
            self.usage_type = self._enum_matching(
                usage_type, CompanyPhoneNumberInfoUsageType.list(), "usage_type"
            )
        if temporary_number is not None:
            self.temporary_number = self._define_object(
                temporary_number, TemporaryNumberInfo
            )
        if contact_center_provider is not None:
            self.contact_center_provider = self._define_object(
                contact_center_provider, ContactCenterProvider
            )
        if vanity_pattern is not None:
            self.vanity_pattern = vanity_pattern
        if primary is not None:
            self.primary = primary
