# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .device_info_request import DeviceInfoRequest
from .sip_info_request import SipInfoRequest


class SoftPhoneLineReassignment(Enum):
    """An enumeration representing different categories.

    :cvar NONE: "None"
    :vartype NONE: str
    :cvar INITIALIZE: "Initialize"
    :vartype INITIALIZE: str
    :cvar REASSIGN: "Reassign"
    :vartype REASSIGN: str
    """

    NONE = "None"
    INITIALIZE = "Initialize"
    REASSIGN = "Reassign"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, SoftPhoneLineReassignment._member_map_.values())
        )


@JsonMap(
    {"sip_info": "sipInfo", "soft_phone_line_reassignment": "softPhoneLineReassignment"}
)
class CreateSipRegistrationRequest(BaseModel):
    """CreateSipRegistrationRequest

    :param device: Device information, defaults to None
    :type device: DeviceInfoRequest, optional
    :param sip_info: SIP settings for device, defaults to None
    :type sip_info: List[SipInfoRequest], optional
    :param soft_phone_line_reassignment: Supported for Softphone clients only. If 'SoftphoneLineReassignment' feature is enabled<br>the reassignment process can be initialized, however if there is no DL for the given user's device<br>then SPR-131 error code will be returned.<br>, defaults to None
    :type soft_phone_line_reassignment: SoftPhoneLineReassignment, optional
    """

    def __init__(
        self,
        device: DeviceInfoRequest = None,
        sip_info: List[SipInfoRequest] = None,
        soft_phone_line_reassignment: SoftPhoneLineReassignment = None,
    ):
        if device is not None:
            self.device = self._define_object(device, DeviceInfoRequest)
        if sip_info is not None:
            self.sip_info = self._define_list(sip_info, SipInfoRequest)
        if soft_phone_line_reassignment is not None:
            self.soft_phone_line_reassignment = self._enum_matching(
                soft_phone_line_reassignment,
                SoftPhoneLineReassignment.list(),
                "soft_phone_line_reassignment",
            )
