# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .emergency_address_auto_update_site_info import EmergencyAddressAutoUpdateSiteInfo
from .emergency_address_info import EmergencyAddressInfo, EmergencyAddressInfoGuard
from .emergency_location_info import EmergencyLocationInfo


@JsonMap(
    {"emergency_address": "emergencyAddress", "emergency_location": "emergencyLocation"}
)
class CreateWirelessPoint(BaseModel):
    """CreateWirelessPoint

    :param bssid: Unique 48-bit identifier of wireless access point that follows MAC address conventions.  Mask: XX:XX:XX:XX:XX:XX, where X can be a symbol in the range of 0-9 or A-F
    :type bssid: str
    :param name: Wireless access point name
    :type name: str
    :param site: site, defaults to None
    :type site: EmergencyAddressAutoUpdateSiteInfo, optional
    :param emergency_address: emergency_address, defaults to None
    :type emergency_address: EmergencyAddressInfo, optional
    :param emergency_location: Emergency response location information, defaults to None
    :type emergency_location: EmergencyLocationInfo, optional
    """

    def __init__(
        self,
        bssid: str,
        name: str,
        site: EmergencyAddressAutoUpdateSiteInfo = None,
        emergency_address: EmergencyAddressInfo = None,
        emergency_location: EmergencyLocationInfo = None,
    ):
        self.bssid = bssid
        self.name = name
        if site is not None:
            self.site = self._define_object(site, EmergencyAddressAutoUpdateSiteInfo)
        if emergency_address is not None:
            self.emergency_address = EmergencyAddressInfoGuard.return_one_of(
                emergency_address
            )
        if emergency_location is not None:
            self.emergency_location = self._define_object(
                emergency_location, EmergencyLocationInfo
            )
