# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"id_": "id", "phone_number": "phoneNumber"})
class DeletePhoneNumbersRequestItem(BaseModel):
    """The indication of a number to be deleted - either "id" or "phoneNumber" must be specified.

    :param id_: Internal unique identifier of a phone number, defaults to None
    :type id_: str, optional
    :param phone_number: Phone number in e.164 format (with '+' prefix), defaults to None
    :type phone_number: str, optional
    """

    def __init__(self, id_: str = None, phone_number: str = None):
        if id_ is not None:
            self.id_ = self._pattern_matching(id_, "^[1-9]\d{1,14}$", "id_")
        if phone_number is not None:
            self.phone_number = self._pattern_matching(
                phone_number, "^\+[1-9]\d{1,14}$", "phone_number"
            )
