# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .extension_info import ExtensionInfo
from .page_navigation_model import PageNavigationModel
from .enumerated_paging_model import EnumeratedPagingModel


@JsonMap({})
class DepartmentMemberList(BaseModel):
    """Please note that legacy 'Department' extension type corresponds to
    'Call Queue' extensions in modern RingCentral product terminology


    :param uri: Canonical URL of the resource, defaults to None
    :type uri: str, optional
    :param records: List of call queue member extensions, defaults to None
    :type records: List[ExtensionInfo], optional
    :param navigation: Links to other pages of the current result set, defaults to None
    :type navigation: PageNavigationModel, optional
    :param paging: paging, defaults to None
    :type paging: EnumeratedPagingModel, optional
    """

    def __init__(
        self,
        uri: str = None,
        records: List[ExtensionInfo] = None,
        navigation: PageNavigationModel = None,
        paging: EnumeratedPagingModel = None,
    ):
        if uri is not None:
            self.uri = uri
        if records is not None:
            self.records = self._define_list(records, ExtensionInfo)
        if navigation is not None:
            self.navigation = self._define_object(navigation, PageNavigationModel)
        if paging is not None:
            self.paging = self._define_object(paging, EnumeratedPagingModel)
