# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from typing import Union
from .utils.json_map import JsonMap
from .base import BaseModel
from .base import OneOfBaseModel
from .postal_address import PostalAddress
from .phone_number_definition_toll_type import PhoneNumberDefinitionTollType
from .phone_number_definition_preferred_area_code import (
    PhoneNumberDefinitionPreferredAreaCode,
)
from .phone_number_definition_direct_number_with_reservation_id import (
    PhoneNumberDefinitionDirectNumberWithReservationId,
)
from .phone_number_definition_number_id import PhoneNumberDefinitionNumberId


class DeviceDefinitionType(Enum):
    """An enumeration representing different categories.

    :cvar OTHERPHONE: "OtherPhone"
    :vartype OTHERPHONE: str
    :cvar WEBRTC: "WebRTC"
    :vartype WEBRTC: str
    """

    OTHERPHONE = "OtherPhone"
    WEBRTC = "WebRTC"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, DeviceDefinitionType._member_map_.values()))


@JsonMap({})
class Emergency1_1(BaseModel):
    """Emergency1_1

    :param address: Postal address/location
    :type address: PostalAddress
    """

    def __init__(self, address: PostalAddress):
        self.address = self._define_object(address, PostalAddress)


@JsonMap({"id_": "id"})
class Emergency2Location1(BaseModel):
    """Emergency2Location1

    :param id_: Emergency location ID
    :type id_: str
    """

    def __init__(self, id_: str):
        self.id_ = id_


@JsonMap({})
class Emergency2_1(BaseModel):
    """Emergency2_1

    :param location: location
    :type location: Emergency2Location1
    """

    def __init__(self, location: Emergency2Location1):
        self.location = self._define_object(location, Emergency2Location1)


class DeviceDefinitionEmergencyGuard(OneOfBaseModel):
    class_list = {"Emergency1_1": Emergency1_1, "Emergency2_1": Emergency2_1}


DeviceDefinitionEmergency = Union[Emergency1_1, Emergency2_1]


class DeviceDefinitionPhoneInfoGuard(OneOfBaseModel):
    class_list = {
        "PhoneNumberDefinitionTollType": PhoneNumberDefinitionTollType,
        "PhoneNumberDefinitionPreferredAreaCode": PhoneNumberDefinitionPreferredAreaCode,
        "PhoneNumberDefinitionDirectNumberWithReservationId": PhoneNumberDefinitionDirectNumberWithReservationId,
        "PhoneNumberDefinitionNumberId": PhoneNumberDefinitionNumberId,
    }


DeviceDefinitionPhoneInfo = Union[
    PhoneNumberDefinitionTollType,
    PhoneNumberDefinitionPreferredAreaCode,
    PhoneNumberDefinitionDirectNumberWithReservationId,
    PhoneNumberDefinitionNumberId,
]


@JsonMap({"type_": "type", "phone_info": "phoneInfo"})
class DeviceDefinition(BaseModel):
    """DeviceDefinition

    :param type_: Device type. Only "OtherPhone" and "WebRTC" device types are supported at the moment
    :type type_: DeviceDefinitionType
    :param emergency: Only "address" is supported at the moment
    :type emergency: DeviceDefinitionEmergency
    :param phone_info: phone_info
    :type phone_info: DeviceDefinitionPhoneInfo
    """

    def __init__(
        self,
        type_: DeviceDefinitionType,
        emergency: DeviceDefinitionEmergency,
        phone_info: DeviceDefinitionPhoneInfo,
    ):
        self.type_ = self._enum_matching(type_, DeviceDefinitionType.list(), "type_")
        self.emergency = DeviceDefinitionEmergencyGuard.return_one_of(emergency)
        self.phone_info = DeviceDefinitionPhoneInfoGuard.return_one_of(phone_info)
