# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel
from .common_emergency_location_address_info_default import (
    CommonEmergencyLocationAddressInfoDefault,
)
from .device_emergency_location_info import DeviceEmergencyLocationInfo


class DeviceEmergencyInfoAddressStatus(Enum):
    """An enumeration representing different categories.

    :cvar VALID: "Valid"
    :vartype VALID: str
    :cvar INVALID: "Invalid"
    :vartype INVALID: str
    :cvar PROVISIONING: "Provisioning"
    :vartype PROVISIONING: str
    """

    VALID = "Valid"
    INVALID = "Invalid"
    PROVISIONING = "Provisioning"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                DeviceEmergencyInfoAddressStatus._member_map_.values(),
            )
        )


class DeviceEmergencyInfoVisibility(Enum):
    """An enumeration representing different categories.

    :cvar PRIVATE: "Private"
    :vartype PRIVATE: str
    :cvar PUBLIC: "Public"
    :vartype PUBLIC: str
    """

    PRIVATE = "Private"
    PUBLIC = "Public"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, DeviceEmergencyInfoVisibility._member_map_.values())
        )


class DeviceEmergencyInfoSyncStatus(Enum):
    """An enumeration representing different categories.

    :cvar VERIFIED: "Verified"
    :vartype VERIFIED: str
    :cvar UPDATED: "Updated"
    :vartype UPDATED: str
    :cvar DELETED: "Deleted"
    :vartype DELETED: str
    :cvar NOTREQUIRED: "NotRequired"
    :vartype NOTREQUIRED: str
    :cvar UNSUPPORTED: "Unsupported"
    :vartype UNSUPPORTED: str
    :cvar FAILED: "Failed"
    :vartype FAILED: str
    """

    VERIFIED = "Verified"
    UPDATED = "Updated"
    DELETED = "Deleted"
    NOTREQUIRED = "NotRequired"
    UNSUPPORTED = "Unsupported"
    FAILED = "Failed"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, DeviceEmergencyInfoSyncStatus._member_map_.values())
        )


class DeviceEmergencyInfoAddressEditableStatus(Enum):
    """An enumeration representing different categories.

    :cvar MAINDEVICE: "MainDevice"
    :vartype MAINDEVICE: str
    :cvar ANYDEVICE: "AnyDevice"
    :vartype ANYDEVICE: str
    """

    MAINDEVICE = "MainDevice"
    ANYDEVICE = "AnyDevice"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                DeviceEmergencyInfoAddressEditableStatus._member_map_.values(),
            )
        )


@JsonMap(
    {
        "out_of_country": "outOfCountry",
        "address_status": "addressStatus",
        "sync_status": "syncStatus",
        "address_editable_status": "addressEditableStatus",
    }
)
class DeviceEmergencyInfo(BaseModel):
    """Device emergency settings

    :param address: address, defaults to None
    :type address: CommonEmergencyLocationAddressInfoDefault, optional
    :param location: Company emergency response location details, defaults to None
    :type location: DeviceEmergencyLocationInfo, optional
    :param out_of_country: Specifies if emergency address is out of country, defaults to None
    :type out_of_country: bool, optional
    :param address_status: Emergency address status, defaults to None
    :type address_status: DeviceEmergencyInfoAddressStatus, optional
    :param visibility: Visibility of an emergency response location. If `Private`<br>is set, then location is visible only for the restricted number of users,<br>specified in `owners` array<br>, defaults to None
    :type visibility: DeviceEmergencyInfoVisibility, optional
    :param sync_status: Resulting status of the emergency address synchronization. Returned<br>if `syncEmergencyAddress` parameter is set to `true`<br>, defaults to None
    :type sync_status: DeviceEmergencyInfoSyncStatus, optional
    :param address_editable_status: Ability to register new emergency address for a phone line<br>using devices sharing this line or only main device (line owner)<br>, defaults to None
    :type address_editable_status: DeviceEmergencyInfoAddressEditableStatus, optional
    """

    def __init__(
        self,
        address: CommonEmergencyLocationAddressInfoDefault = None,
        location: DeviceEmergencyLocationInfo = None,
        out_of_country: bool = None,
        address_status: DeviceEmergencyInfoAddressStatus = None,
        visibility: DeviceEmergencyInfoVisibility = None,
        sync_status: DeviceEmergencyInfoSyncStatus = None,
        address_editable_status: DeviceEmergencyInfoAddressEditableStatus = None,
    ):
        if address is not None:
            self.address = self._define_object(
                address, CommonEmergencyLocationAddressInfoDefault
            )
        if location is not None:
            self.location = self._define_object(location, DeviceEmergencyLocationInfo)
        if out_of_country is not None:
            self.out_of_country = out_of_country
        if address_status is not None:
            self.address_status = self._enum_matching(
                address_status,
                DeviceEmergencyInfoAddressStatus.list(),
                "address_status",
            )
        if visibility is not None:
            self.visibility = self._enum_matching(
                visibility, DeviceEmergencyInfoVisibility.list(), "visibility"
            )
        if sync_status is not None:
            self.sync_status = self._enum_matching(
                sync_status, DeviceEmergencyInfoSyncStatus.list(), "sync_status"
            )
        if address_editable_status is not None:
            self.address_editable_status = self._enum_matching(
                address_editable_status,
                DeviceEmergencyInfoAddressEditableStatus.list(),
                "address_editable_status",
            )
