# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "customer_name": "customerName",
        "state_id": "stateId",
        "state_iso_code": "stateIsoCode",
        "state_name": "stateName",
        "country_id": "countryId",
        "country_iso_code": "countryIsoCode",
        "country_name": "countryName",
        "out_of_country": "outOfCountry",
        "building_name": "buildingName",
        "street_type": "streetType",
        "building_number": "buildingNumber",
    }
)
class DeviceEmergencyServiceAddressResourceAu(BaseModel):
    """Address for emergency cases. The same emergency address is assigned to all the numbers of one device

    :param street: street, defaults to None
    :type street: str, optional
    :param street2: street2, defaults to None
    :type street2: str, optional
    :param city: city, defaults to None
    :type city: str, optional
    :param zip: zip, defaults to None
    :type zip: str, optional
    :param customer_name: customer_name, defaults to None
    :type customer_name: str, optional
    :param state: State/province name, defaults to None
    :type state: str, optional
    :param state_id: Internal identifier of a state, defaults to None
    :type state_id: str, optional
    :param state_iso_code: ISO code of a state, defaults to None
    :type state_iso_code: str, optional
    :param state_name: Full name of a state, defaults to None
    :type state_name: str, optional
    :param country_id: Internal identifier of a country, defaults to None
    :type country_id: str, optional
    :param country_iso_code: ISO code of a country, defaults to None
    :type country_iso_code: str, optional
    :param country: Country name, defaults to None
    :type country: str, optional
    :param country_name: Full name of a country, defaults to None
    :type country_name: str, optional
    :param out_of_country: Specifies if emergency address is out of country, defaults to None
    :type out_of_country: bool, optional
    :param building_name: (Optional) Building name, defaults to None
    :type building_name: str, optional
    :param street_type: Street type, defaults to None
    :type street_type: str, optional
    :param building_number: Building/street number, defaults to None
    :type building_number: str, optional
    """

    def __init__(
        self,
        street: str = None,
        street2: str = None,
        city: str = None,
        zip: str = None,
        customer_name: str = None,
        state: str = None,
        state_id: str = None,
        state_iso_code: str = None,
        state_name: str = None,
        country_id: str = None,
        country_iso_code: str = None,
        country: str = None,
        country_name: str = None,
        out_of_country: bool = None,
        building_name: str = None,
        street_type: str = None,
        building_number: str = None,
    ):
        if street is not None:
            self.street = street
        if street2 is not None:
            self.street2 = street2
        if city is not None:
            self.city = city
        if zip is not None:
            self.zip = zip
        if customer_name is not None:
            self.customer_name = customer_name
        if state is not None:
            self.state = state
        if state_id is not None:
            self.state_id = state_id
        if state_iso_code is not None:
            self.state_iso_code = state_iso_code
        if state_name is not None:
            self.state_name = state_name
        if country_id is not None:
            self.country_id = country_id
        if country_iso_code is not None:
            self.country_iso_code = country_iso_code
        if country is not None:
            self.country = country
        if country_name is not None:
            self.country_name = country_name
        if out_of_country is not None:
            self.out_of_country = out_of_country
        if building_name is not None:
            self.building_name = building_name
        if street_type is not None:
            self.street_type = street_type
        if building_number is not None:
            self.building_number = building_number
