# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {"customer_name": "customerName", "state_id": "stateId", "country_id": "countryId"}
)
class EmergencyServiceAddressResourceRequest(BaseModel):
    """Address for emergency cases. The same emergency address is assigned to all
    numbers of a single device. If the emergency address is also specified in
    `emergency` resource, then this value is ignored


    :param street: street, defaults to None
    :type street: str, optional
    :param street2: street2, defaults to None
    :type street2: str, optional
    :param city: city, defaults to None
    :type city: str, optional
    :param zip: zip, defaults to None
    :type zip: str, optional
    :param customer_name: customer_name, defaults to None
    :type customer_name: str, optional
    :param state: State/province name, defaults to None
    :type state: str, optional
    :param state_id: Internal identifier of a state, defaults to None
    :type state_id: str, optional
    :param country: Country name, defaults to None
    :type country: str, optional
    :param country_id: Internal identifier of a country, defaults to None
    :type country_id: str, optional
    """

    def __init__(
        self,
        street: str = None,
        street2: str = None,
        city: str = None,
        zip: str = None,
        customer_name: str = None,
        state: str = None,
        state_id: str = None,
        country: str = None,
        country_id: str = None,
    ):
        if street is not None:
            self.street = street
        if street2 is not None:
            self.street2 = street2
        if city is not None:
            self.city = city
        if zip is not None:
            self.zip = zip
        if customer_name is not None:
            self.customer_name = customer_name
        if state is not None:
            self.state = state
        if state_id is not None:
            self.state_id = state_id
        if country is not None:
            self.country = country
        if country_id is not None:
            self.country_id = country_id
