# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


class EveryoneTeamInfoType(Enum):
    """An enumeration representing different categories.

    :cvar EVERYONE: "Everyone"
    :vartype EVERYONE: str
    """

    EVERYONE = "Everyone"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, EveryoneTeamInfoType._member_map_.values()))


@JsonMap(
    {
        "id_": "id",
        "type_": "type",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class EveryoneTeamInfo(BaseModel):
    """EveryoneTeamInfo

    :param id_: Internal identifier of a chat, defaults to None
    :type id_: str, optional
    :param type_: Type of chat, defaults to None
    :type type_: EveryoneTeamInfoType, optional
    :param name: Chat name, defaults to None
    :type name: str, optional
    :param description: Chat description, defaults to None
    :type description: str, optional
    :param creation_time: Chat creation datetime in ISO 8601 format, defaults to None
    :type creation_time: str, optional
    :param last_modified_time: Chat last change datetime in ISO 8601 format, defaults to None
    :type last_modified_time: str, optional
    """

    def __init__(
        self,
        id_: str = None,
        type_: EveryoneTeamInfoType = None,
        name: str = None,
        description: str = None,
        creation_time: str = None,
        last_modified_time: str = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if type_ is not None:
            self.type_ = self._enum_matching(
                type_, EveryoneTeamInfoType.list(), "type_"
            )
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if creation_time is not None:
            self.creation_time = creation_time
        if last_modified_time is not None:
            self.last_modified_time = last_modified_time
