# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel
from .extension_bulk_update_task_result import ExtensionBulkUpdateTaskResult


class ExtensionBulkUpdateTaskResourceStatus(Enum):
    """An enumeration representing different categories.

    :cvar ACCEPTED: "Accepted"
    :vartype ACCEPTED: str
    :cvar INPROGRESS: "InProgress"
    :vartype INPROGRESS: str
    :cvar COMPLETED: "Completed"
    :vartype COMPLETED: str
    :cvar FAILED: "Failed"
    :vartype FAILED: str
    """

    ACCEPTED = "Accepted"
    INPROGRESS = "InProgress"
    COMPLETED = "Completed"
    FAILED = "Failed"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                ExtensionBulkUpdateTaskResourceStatus._member_map_.values(),
            )
        )


@JsonMap(
    {
        "id_": "id",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class ExtensionBulkUpdateTaskResource(BaseModel):
    """Information on a task for updating multiple extensions


    :param uri: Link to a task resource
    :type uri: str
    :param id_: Internal identifier of a task
    :type id_: str
    :param status: Task status
    :type status: ExtensionBulkUpdateTaskResourceStatus
    :param creation_time: Task creation date/time
    :type creation_time: str
    :param last_modified_time: Task latest update date/time
    :type last_modified_time: str
    :param result: Result record on multiple extension update task, defaults to None
    :type result: ExtensionBulkUpdateTaskResult, optional
    """

    def __init__(
        self,
        uri: str,
        id_: str,
        status: ExtensionBulkUpdateTaskResourceStatus,
        creation_time: str,
        last_modified_time: str,
        result: ExtensionBulkUpdateTaskResult = None,
    ):
        self.uri = uri
        self.id_ = id_
        self.status = self._enum_matching(
            status, ExtensionBulkUpdateTaskResourceStatus.list(), "status"
        )
        self.creation_time = creation_time
        self.last_modified_time = last_modified_time
        if result is not None:
            self.result = self._define_object(result, ExtensionBulkUpdateTaskResult)
