# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .message_store_caller_info_response_from import MessageStoreCallerInfoResponseFrom
from .fax_response_to import FaxResponseTo
from .message_read_status_enum import MessageReadStatusEnum
from .message_priority_enum import MessagePriorityEnum
from .message_attachment_info_int_id import MessageAttachmentInfoIntId
from .message_direction_enum import MessageDirectionEnum
from .message_availability_enum import MessageAvailabilityEnum
from .message_status_enum import MessageStatusEnum
from .fax_resolution_enum import FaxResolutionEnum


class FaxResponseType(Enum):
    """An enumeration representing different categories.

    :cvar FAX: "Fax"
    :vartype FAX: str
    """

    FAX = "Fax"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, FaxResponseType._member_map_.values()))


@JsonMap(
    {
        "id_": "id",
        "type_": "type",
        "from_": "from",
        "creation_time": "creationTime",
        "read_status": "readStatus",
        "message_status": "messageStatus",
        "fax_resolution": "faxResolution",
        "fax_page_count": "faxPageCount",
        "last_modified_time": "lastModifiedTime",
        "cover_index": "coverIndex",
        "cover_page_text": "coverPageText",
    }
)
class FaxResponse(BaseModel):
    """FaxResponse

    :param id_: Internal identifier of a message, defaults to None
    :type id_: int, optional
    :param uri: Canonical URI of a message, defaults to None
    :type uri: str, optional
    :param type_: Message type - 'Fax', defaults to None
    :type type_: FaxResponseType, optional
    :param from_: Sender information, defaults to None
    :type from_: MessageStoreCallerInfoResponseFrom, optional
    :param to: Recipient information, defaults to None
    :type to: List[FaxResponseTo], optional
    :param creation_time: Message creation date/time in ISO 8601 format including timezone,<br>for example 2016-03-10T18:07:52.534Z<br>, defaults to None
    :type creation_time: str, optional
    :param read_status: Message read status, defaults to None
    :type read_status: MessageReadStatusEnum, optional
    :param priority: Message priority, defaults to None
    :type priority: MessagePriorityEnum, optional
    :param attachments: List of message attachments, defaults to None
    :type attachments: List[MessageAttachmentInfoIntId], optional
    :param direction: Text message direction. Note that for some message types not all<br>directions are allowed. For example voicemail messages can<br>be only inbound<br>, defaults to None
    :type direction: MessageDirectionEnum, optional
    :param availability: Message availability status. Message in 'Deleted' state is still<br>preserved with all its attachments and can be restored. 'Purged' means<br>that all attachments are already deleted and the message itself is about<br>to be physically deleted shortly<br>, defaults to None
    :type availability: MessageAvailabilityEnum, optional
    :param message_status: Message status. Different message types may have different<br>allowed status values. For outbound faxes the aggregated message status<br>is returned. If, for outbound message, a status for at least one recipient is 'Queued', then<br>the 'Queued' value is returned. If a status for at least one recipient is<br>'SendingFailed', then the 'SendingFailed' value is returned. In other cases<br>the 'Sent' status is returned<br>, defaults to None
    :type message_status: MessageStatusEnum, optional
    :param fax_resolution: Fax only. Resolution of a fax message. 'High' for black and<br>white image scanned at 200 dpi, 'Low' for black and white image scanned<br>at 100 dpi<br>, defaults to None
    :type fax_resolution: FaxResolutionEnum, optional
    :param fax_page_count: Page count in a fax message, defaults to None
    :type fax_page_count: int, optional
    :param last_modified_time: Date/time when the message was modified on server in ISO 8601<br>format including timezone, for example 2016-03-10T18:07:52.534Z<br>, defaults to None
    :type last_modified_time: str, optional
    :param cover_index: Cover page identifier. If `coverIndex` is set to '0' (zero), a cover<br>page is not attached. For a list of available cover page identifiers<br>(1-13) please call the Fax Cover Pages method. If not specified,<br>the default cover page is attached (which is configured in<br>'Outbound Fax Settings')<br>, defaults to None
    :type cover_index: int, optional
    :param cover_page_text: Cover page text, entered by a fax sender and printed on a<br>cover page. Maximum length is limited to 1024 symbols<br>, defaults to None
    :type cover_page_text: str, optional
    """

    def __init__(
        self,
        id_: int = None,
        uri: str = None,
        type_: FaxResponseType = None,
        from_: MessageStoreCallerInfoResponseFrom = None,
        to: List[FaxResponseTo] = None,
        creation_time: str = None,
        read_status: MessageReadStatusEnum = None,
        priority: MessagePriorityEnum = None,
        attachments: List[MessageAttachmentInfoIntId] = None,
        direction: MessageDirectionEnum = None,
        availability: MessageAvailabilityEnum = None,
        message_status: MessageStatusEnum = None,
        fax_resolution: FaxResolutionEnum = None,
        fax_page_count: int = None,
        last_modified_time: str = None,
        cover_index: int = None,
        cover_page_text: str = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if uri is not None:
            self.uri = uri
        if type_ is not None:
            self.type_ = self._enum_matching(type_, FaxResponseType.list(), "type_")
        if from_ is not None:
            self.from_ = self._define_object(from_, MessageStoreCallerInfoResponseFrom)
        if to is not None:
            self.to = self._define_list(to, FaxResponseTo)
        if creation_time is not None:
            self.creation_time = creation_time
        if read_status is not None:
            self.read_status = self._enum_matching(
                read_status, MessageReadStatusEnum.list(), "read_status"
            )
        if priority is not None:
            self.priority = self._enum_matching(
                priority, MessagePriorityEnum.list(), "priority"
            )
        if attachments is not None:
            self.attachments = self._define_list(
                attachments, MessageAttachmentInfoIntId
            )
        if direction is not None:
            self.direction = self._enum_matching(
                direction, MessageDirectionEnum.list(), "direction"
            )
        if availability is not None:
            self.availability = self._enum_matching(
                availability, MessageAvailabilityEnum.list(), "availability"
            )
        if message_status is not None:
            self.message_status = self._enum_matching(
                message_status, MessageStatusEnum.list(), "message_status"
            )
        if fax_resolution is not None:
            self.fax_resolution = self._enum_matching(
                fax_resolution, FaxResolutionEnum.list(), "fax_resolution"
            )
        if fax_page_count is not None:
            self.fax_page_count = fax_page_count
        if last_modified_time is not None:
            self.last_modified_time = last_modified_time
        if cover_index is not None:
            self.cover_index = cover_index
        if cover_page_text is not None:
            self.cover_page_text = cover_page_text
