# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"phone_number": "phoneNumber", "extension_number": "extensionNumber"})
class ForwardTarget(BaseModel):
    """Identifier of a call party the call will be forwarded to. Only **one of** these parameters:
    `phoneNumber`, `voicemail` or `extensionNumber` must be specified, otherwise an error is returned.


    :param phone_number: Phone number, defaults to None
    :type phone_number: str, optional
    :param voicemail: Voicemail owner extension identifier, defaults to None
    :type voicemail: str, optional
    :param extension_number: Extension short number, defaults to None
    :type extension_number: str, optional
    """

    def __init__(
        self,
        phone_number: str = None,
        voicemail: str = None,
        extension_number: str = None,
    ):
        if phone_number is not None:
            self.phone_number = phone_number
        if voicemail is not None:
            self.voicemail = voicemail
        if extension_number is not None:
            self.extension_number = extension_number
