# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel
from .contact_info import ContactInfo
from .extension_permissions import ExtensionPermissions
from .profile_image_info import ProfileImageInfo
from .call_queue_extension_info import CallQueueExtensionInfo
from .provisioning_site_info import ProvisioningSiteInfo
from .assigned_country_info import AssignedCountryInfo
from .cost_center_info import CostCenterInfo


class GetExtensionListInfoResponseStatus(Enum):
    """An enumeration representing different categories.

    :cvar ENABLED: "Enabled"
    :vartype ENABLED: str
    :cvar DISABLED: "Disabled"
    :vartype DISABLED: str
    :cvar FROZEN: "Frozen"
    :vartype FROZEN: str
    :cvar NOTACTIVATED: "NotActivated"
    :vartype NOTACTIVATED: str
    :cvar UNASSIGNED: "Unassigned"
    :vartype UNASSIGNED: str
    """

    ENABLED = "Enabled"
    DISABLED = "Disabled"
    FROZEN = "Frozen"
    NOTACTIVATED = "NotActivated"
    UNASSIGNED = "Unassigned"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                GetExtensionListInfoResponseStatus._member_map_.values(),
            )
        )


class GetExtensionListInfoResponseType(Enum):
    """An enumeration representing different categories.

    :cvar USER: "User"
    :vartype USER: str
    :cvar FAXUSER: "FaxUser"
    :vartype FAXUSER: str
    :cvar FLEXIBLEUSER: "FlexibleUser"
    :vartype FLEXIBLEUSER: str
    :cvar VIRTUALUSER: "VirtualUser"
    :vartype VIRTUALUSER: str
    :cvar DIGITALUSER: "DigitalUser"
    :vartype DIGITALUSER: str
    :cvar DEPARTMENT: "Department"
    :vartype DEPARTMENT: str
    :cvar ANNOUNCEMENT: "Announcement"
    :vartype ANNOUNCEMENT: str
    :cvar VOICEMAIL: "Voicemail"
    :vartype VOICEMAIL: str
    :cvar SHAREDLINESGROUP: "SharedLinesGroup"
    :vartype SHAREDLINESGROUP: str
    :cvar PAGINGONLY: "PagingOnly"
    :vartype PAGINGONLY: str
    :cvar IVRMENU: "IvrMenu"
    :vartype IVRMENU: str
    :cvar APPLICATIONEXTENSION: "ApplicationExtension"
    :vartype APPLICATIONEXTENSION: str
    :cvar PARKLOCATION: "ParkLocation"
    :vartype PARKLOCATION: str
    :cvar BOT: "Bot"
    :vartype BOT: str
    :cvar ROOM: "Room"
    :vartype ROOM: str
    :cvar LIMITED: "Limited"
    :vartype LIMITED: str
    :cvar SITE: "Site"
    :vartype SITE: str
    :cvar PROXYADMIN: "ProxyAdmin"
    :vartype PROXYADMIN: str
    :cvar DELEGATEDLINESGROUP: "DelegatedLinesGroup"
    :vartype DELEGATEDLINESGROUP: str
    :cvar GROUPCALLPICKUP: "GroupCallPickup"
    :vartype GROUPCALLPICKUP: str
    """

    USER = "User"
    FAXUSER = "FaxUser"
    FLEXIBLEUSER = "FlexibleUser"
    VIRTUALUSER = "VirtualUser"
    DIGITALUSER = "DigitalUser"
    DEPARTMENT = "Department"
    ANNOUNCEMENT = "Announcement"
    VOICEMAIL = "Voicemail"
    SHAREDLINESGROUP = "SharedLinesGroup"
    PAGINGONLY = "PagingOnly"
    IVRMENU = "IvrMenu"
    APPLICATIONEXTENSION = "ApplicationExtension"
    PARKLOCATION = "ParkLocation"
    BOT = "Bot"
    ROOM = "Room"
    LIMITED = "Limited"
    SITE = "Site"
    PROXYADMIN = "ProxyAdmin"
    DELEGATEDLINESGROUP = "DelegatedLinesGroup"
    GROUPCALLPICKUP = "GroupCallPickup"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                GetExtensionListInfoResponseType._member_map_.values(),
            )
        )


class GetExtensionListInfoResponseSubType(Enum):
    """An enumeration representing different categories.

    :cvar VIDEOPRO: "VideoPro"
    :vartype VIDEOPRO: str
    :cvar VIDEOPROPLUS: "VideoProPlus"
    :vartype VIDEOPROPLUS: str
    :cvar DIGITALSIGNAGE: "DigitalSignage"
    :vartype DIGITALSIGNAGE: str
    :cvar UNKNOWN: "Unknown"
    :vartype UNKNOWN: str
    :cvar EMERGENCY: "Emergency"
    :vartype EMERGENCY: str
    """

    VIDEOPRO = "VideoPro"
    VIDEOPROPLUS = "VideoProPlus"
    DIGITALSIGNAGE = "DigitalSignage"
    UNKNOWN = "Unknown"
    EMERGENCY = "Emergency"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                GetExtensionListInfoResponseSubType._member_map_.values(),
            )
        )


@JsonMap(
    {
        "id_": "id",
        "extension_number": "extensionNumber",
        "profile_image": "profileImage",
        "type_": "type",
        "sub_type": "subType",
        "call_queue_info": "callQueueInfo",
        "assigned_country": "assignedCountry",
        "cost_center": "costCenter",
    }
)
class GetExtensionListInfoResponse(BaseModel):
    """GetExtensionListInfoResponse

    :param id_: Internal identifier of an extension, defaults to None
    :type id_: int, optional
    :param uri: Canonical URI of an extension, defaults to None
    :type uri: str, optional
    :param contact: Detailed contact information, defaults to None
    :type contact: ContactInfo, optional
    :param extension_number: Extension short number, defaults to None
    :type extension_number: str, optional
    :param name: Extension name. For user extension types the value is a combination<br>of the specified first name and last name<br>, defaults to None
    :type name: str, optional
    :param permissions: Extension permissions, corresponding to the Service Web permissions<br>'Admin' and 'InternationalCalling'<br>, defaults to None
    :type permissions: ExtensionPermissions, optional
    :param profile_image: Information on profile image, defaults to None
    :type profile_image: ProfileImageInfo, optional
    :param status: Extension current state. If 'Unassigned' is specified, then<br>extensions without `extensionNumber` are returned. If not specified,<br>then all extensions are returned<br>, defaults to None
    :type status: GetExtensionListInfoResponseStatus, optional
    :param type_: Extension type. Please note that legacy 'Department' extension type<br>corresponds to 'Call Queue' extensions in modern RingCentral product<br>terminology<br>, defaults to None
    :type type_: GetExtensionListInfoResponseType, optional
    :param sub_type: Extension subtype, if applicable. For any unsupported subtypes the<br>`Unknown` value will be returned<br>, defaults to None
    :type sub_type: GetExtensionListInfoResponseSubType, optional
    :param call_queue_info: For Call Queue extension type only. Please note that legacy<br>'Department' extension type corresponds to 'Call Queue' extensions<br>in modern RingCentral product terminology<br>, defaults to None
    :type call_queue_info: CallQueueExtensionInfo, optional
    :param hidden: Hides extension from showing in company directory.<br>Supported for extensions of User type only<br>, defaults to None
    :type hidden: bool, optional
    :param site: Site data. If multi-site feature is turned on for an account,<br>then ID of a site must be specified. In order to assign a wireless<br>point to the main site (company) the site ID should be set to `main-site`<br>, defaults to None
    :type site: ProvisioningSiteInfo, optional
    :param assigned_country: Information on a country assigned to an extension user. Returned for the User extension type only, defaults to None
    :type assigned_country: AssignedCountryInfo, optional
    :param cost_center: Cost center information. Applicable if Cost Center feature is enabled. The default is `root` cost center value, defaults to None
    :type cost_center: CostCenterInfo, optional
    """

    def __init__(
        self,
        id_: int = None,
        uri: str = None,
        contact: ContactInfo = None,
        extension_number: str = None,
        name: str = None,
        permissions: ExtensionPermissions = None,
        profile_image: ProfileImageInfo = None,
        status: GetExtensionListInfoResponseStatus = None,
        type_: GetExtensionListInfoResponseType = None,
        sub_type: GetExtensionListInfoResponseSubType = None,
        call_queue_info: CallQueueExtensionInfo = None,
        hidden: bool = None,
        site: ProvisioningSiteInfo = None,
        assigned_country: AssignedCountryInfo = None,
        cost_center: CostCenterInfo = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if uri is not None:
            self.uri = uri
        if contact is not None:
            self.contact = self._define_object(contact, ContactInfo)
        if extension_number is not None:
            self.extension_number = extension_number
        if name is not None:
            self.name = name
        if permissions is not None:
            self.permissions = self._define_object(permissions, ExtensionPermissions)
        if profile_image is not None:
            self.profile_image = self._define_object(profile_image, ProfileImageInfo)
        if status is not None:
            self.status = self._enum_matching(
                status, GetExtensionListInfoResponseStatus.list(), "status"
            )
        if type_ is not None:
            self.type_ = self._enum_matching(
                type_, GetExtensionListInfoResponseType.list(), "type_"
            )
        if sub_type is not None:
            self.sub_type = self._enum_matching(
                sub_type, GetExtensionListInfoResponseSubType.list(), "sub_type"
            )
        if call_queue_info is not None:
            self.call_queue_info = self._define_object(
                call_queue_info, CallQueueExtensionInfo
            )
        if hidden is not None:
            self.hidden = hidden
        if site is not None:
            self.site = self._define_object(site, ProvisioningSiteInfo)
        if assigned_country is not None:
            self.assigned_country = self._define_object(
                assigned_country, AssignedCountryInfo
            )
        if cost_center is not None:
            self.cost_center = self._define_object(cost_center, CostCenterInfo)
