# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .message_attachment_info import MessageAttachmentInfo
from .message_availability_enum import MessageAvailabilityEnum
from .conversation_info import ConversationInfo
from .message_direction_enum import MessageDirectionEnum
from .message_store_caller_info_response_from import MessageStoreCallerInfoResponseFrom
from .message_status_enum import MessageStatusEnum
from .message_priority_enum import MessagePriorityEnum
from .message_read_status_enum import MessageReadStatusEnum
from .message_store_caller_info_response_to import MessageStoreCallerInfoResponseTo


class GetSmsMessageInfoResponseType(Enum):
    """An enumeration representing different categories.

    :cvar FAX: "Fax"
    :vartype FAX: str
    :cvar SMS: "SMS"
    :vartype SMS: str
    :cvar VOICEMAIL: "VoiceMail"
    :vartype VOICEMAIL: str
    :cvar PAGER: "Pager"
    :vartype PAGER: str
    :cvar TEXT: "Text"
    :vartype TEXT: str
    """

    FAX = "Fax"
    SMS = "SMS"
    VOICEMAIL = "VoiceMail"
    PAGER = "Pager"
    TEXT = "Text"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, GetSmsMessageInfoResponseType._member_map_.values())
        )


@JsonMap(
    {
        "id_": "id",
        "conversation_id": "conversationId",
        "creation_time": "creationTime",
        "delivery_error_code": "deliveryErrorCode",
        "from_": "from",
        "last_modified_time": "lastModifiedTime",
        "message_status": "messageStatus",
        "read_status": "readStatus",
        "sms_delivery_time": "smsDeliveryTime",
        "sms_sending_attempts_count": "smsSendingAttemptsCount",
        "type_": "type",
    }
)
class GetSmsMessageInfoResponse(BaseModel):
    """GetSmsMessageInfoResponse

    :param id_: Internal identifier of a message, defaults to None
    :type id_: int, optional
    :param uri: Canonical URI of a message, defaults to None
    :type uri: str, optional
    :param attachments: List of message attachments, defaults to None
    :type attachments: List[MessageAttachmentInfo], optional
    :param availability: Message availability status. Message in 'Deleted' state is still<br>preserved with all its attachments and can be restored. 'Purged' means<br>that all attachments are already deleted and the message itself is about<br>to be physically deleted shortly<br>, defaults to None
    :type availability: MessageAvailabilityEnum, optional
    :param conversation_id: SMS and Pager only. Identifier of a conversation that the message<br>belongs to<br>, defaults to None
    :type conversation_id: int, optional
    :param conversation: SMS and Pager only. Information about a conversation the message belongs to, defaults to None
    :type conversation: ConversationInfo, optional
    :param creation_time: Message creation date/time in ISO 8601 format including timezone,<br>for example 2016-03-10T18:07:52.534Z<br>, defaults to None
    :type creation_time: str, optional
    :param delivery_error_code: SMS only. Delivery error code returned by gateway, defaults to None
    :type delivery_error_code: str, optional
    :param direction: Text message direction. Note that for some message types not all<br>directions are allowed. For example voicemail messages can<br>be only inbound<br>, defaults to None
    :type direction: MessageDirectionEnum, optional
    :param from_: Sender information, defaults to None
    :type from_: MessageStoreCallerInfoResponseFrom, optional
    :param last_modified_time: Date/time when the message was modified on server in ISO<br>8601 format including timezone, for example 2016-03-10T18:07:52.534Z<br>, defaults to None
    :type last_modified_time: str, optional
    :param message_status: Message status. Different message types may have different<br>allowed status values. For outbound faxes the aggregated message status<br>is returned. If, for outbound message, a status for at least one recipient is 'Queued', then<br>the 'Queued' value is returned. If a status for at least one recipient is<br>'SendingFailed', then the 'SendingFailed' value is returned. In other cases<br>the 'Sent' status is returned<br>, defaults to None
    :type message_status: MessageStatusEnum, optional
    :param priority: Message priority, defaults to None
    :type priority: MessagePriorityEnum, optional
    :param read_status: Message read status, defaults to None
    :type read_status: MessageReadStatusEnum, optional
    :param sms_delivery_time: SMS only. The date/time when outbound SMS was delivered to<br>recipient's handset in ISO 8601 format including timezone,<br>for example 2016-03-10T18:07:52.534Z. It is filled only if<br>the carrier sends a delivery receipt to RingCentral<br>, defaults to None
    :type sms_delivery_time: str, optional
    :param sms_sending_attempts_count: SMS only. Number of attempts made to send an outbound SMS to<br>the Gateway (if Gateway is temporary unavailable)<br>, defaults to None
    :type sms_sending_attempts_count: int, optional
    :param subject: Message subject. For SMS and Pager messages it replicates message<br>text which is also returned as an attachment<br>, defaults to None
    :type subject: str, optional
    :param to: Recipient information, defaults to None
    :type to: List[MessageStoreCallerInfoResponseTo], optional
    :param type_: Message type, defaults to None
    :type type_: GetSmsMessageInfoResponseType, optional
    """

    def __init__(
        self,
        id_: int = None,
        uri: str = None,
        attachments: List[MessageAttachmentInfo] = None,
        availability: MessageAvailabilityEnum = None,
        conversation_id: int = None,
        conversation: ConversationInfo = None,
        creation_time: str = None,
        delivery_error_code: str = None,
        direction: MessageDirectionEnum = None,
        from_: MessageStoreCallerInfoResponseFrom = None,
        last_modified_time: str = None,
        message_status: MessageStatusEnum = None,
        priority: MessagePriorityEnum = None,
        read_status: MessageReadStatusEnum = None,
        sms_delivery_time: str = None,
        sms_sending_attempts_count: int = None,
        subject: str = None,
        to: List[MessageStoreCallerInfoResponseTo] = None,
        type_: GetSmsMessageInfoResponseType = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if uri is not None:
            self.uri = uri
        if attachments is not None:
            self.attachments = self._define_list(attachments, MessageAttachmentInfo)
        if availability is not None:
            self.availability = self._enum_matching(
                availability, MessageAvailabilityEnum.list(), "availability"
            )
        if conversation_id is not None:
            self.conversation_id = conversation_id
        if conversation is not None:
            self.conversation = self._define_object(conversation, ConversationInfo)
        if creation_time is not None:
            self.creation_time = creation_time
        if delivery_error_code is not None:
            self.delivery_error_code = delivery_error_code
        if direction is not None:
            self.direction = self._enum_matching(
                direction, MessageDirectionEnum.list(), "direction"
            )
        if from_ is not None:
            self.from_ = self._define_object(from_, MessageStoreCallerInfoResponseFrom)
        if last_modified_time is not None:
            self.last_modified_time = last_modified_time
        if message_status is not None:
            self.message_status = self._enum_matching(
                message_status, MessageStatusEnum.list(), "message_status"
            )
        if priority is not None:
            self.priority = self._enum_matching(
                priority, MessagePriorityEnum.list(), "priority"
            )
        if read_status is not None:
            self.read_status = self._enum_matching(
                read_status, MessageReadStatusEnum.list(), "read_status"
            )
        if sms_delivery_time is not None:
            self.sms_delivery_time = sms_delivery_time
        if sms_sending_attempts_count is not None:
            self.sms_sending_attempts_count = sms_sending_attempts_count
        if subject is not None:
            self.subject = subject
        if to is not None:
            self.to = self._define_list(to, MessageStoreCallerInfoResponseTo)
        if type_ is not None:
            self.type_ = self._enum_matching(
                type_, GetSmsMessageInfoResponseType.list(), "type_"
            )
