# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


class CreateCustomUserGreetingRequestType2(Enum):
    """An enumeration representing different categories.

    :cvar INTRODUCTORY: "Introductory"
    :vartype INTRODUCTORY: str
    :cvar ANNOUNCEMENT: "Announcement"
    :vartype ANNOUNCEMENT: str
    :cvar CONNECTINGMESSAGE: "ConnectingMessage"
    :vartype CONNECTINGMESSAGE: str
    :cvar CONNECTINGAUDIO: "ConnectingAudio"
    :vartype CONNECTINGAUDIO: str
    :cvar VOICEMAIL: "Voicemail"
    :vartype VOICEMAIL: str
    :cvar UNAVAILABLE: "Unavailable"
    :vartype UNAVAILABLE: str
    :cvar HOLDMUSIC: "HoldMusic"
    :vartype HOLDMUSIC: str
    :cvar TEMPLATEGREETING: "TemplateGreeting"
    :vartype TEMPLATEGREETING: str
    """

    INTRODUCTORY = "Introductory"
    ANNOUNCEMENT = "Announcement"
    CONNECTINGMESSAGE = "ConnectingMessage"
    CONNECTINGAUDIO = "ConnectingAudio"
    VOICEMAIL = "Voicemail"
    UNAVAILABLE = "Unavailable"
    HOLDMUSIC = "HoldMusic"
    TEMPLATEGREETING = "TemplateGreeting"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                CreateCustomUserGreetingRequestType2._member_map_.values(),
            )
        )


@JsonMap({"type_": "type", "answering_rule_id": "answeringRuleId"})
class GreetingsCreateCustomUserGreetingRequest2(BaseModel):
    """GreetingsCreateCustomUserGreetingRequest2

    :param type_: Type of greeting, specifying the case when the greeting is played.
    :type type_: CreateCustomUserGreetingRequestType2
    :param answering_rule_id: Internal identifier of an answering rule
    :type answering_rule_id: str
    :param binary: Media file to upload
    :type binary: any
    """

    def __init__(
        self,
        type_: CreateCustomUserGreetingRequestType2,
        answering_rule_id: str,
        binary: any,
    ):
        self.type_ = self._enum_matching(
            type_, CreateCustomUserGreetingRequestType2.list(), "type_"
        )
        self.answering_rule_id = answering_rule_id
        self.binary = binary
