# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "id_": "id",
        "formatting_locale": "formattingLocale",
        "locale_code": "localeCode",
        "iso_code": "isoCode",
        "time_format": "timeFormat",
        "date_format": "dateFormat",
    }
)
class LanguageInfo(BaseModel):
    """User interface language data

    :param id_: Internal identifier of a language, defaults to None
    :type id_: str, optional
    :param uri: Canonical URI of a language, defaults to None
    :type uri: str, optional
    :param greeting: Indicates whether a language is available as<br>greeting language<br>, defaults to None
    :type greeting: bool, optional
    :param formatting_locale: Indicates whether a language is available as<br>formatting locale<br>, defaults to None
    :type formatting_locale: bool, optional
    :param locale_code: Localization code of a language, defaults to None
    :type locale_code: str, optional
    :param iso_code: Country code according to the ISO standard, see [ISO 3166](https://www.iso.org/iso-3166-country-codes.html), defaults to None
    :type iso_code: str, optional
    :param name: Official name of a language, defaults to None
    :type name: str, optional
    :param ui: Indicates whether a language is available as UI language<br>, defaults to None
    :type ui: bool, optional
    :param time_format: Time format, defaults to None
    :type time_format: str, optional
    :param date_format: Date format, defaults to None
    :type date_format: str, optional
    """

    def __init__(
        self,
        id_: str = None,
        uri: str = None,
        greeting: bool = None,
        formatting_locale: bool = None,
        locale_code: str = None,
        iso_code: str = None,
        name: str = None,
        ui: bool = None,
        time_format: str = None,
        date_format: str = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if uri is not None:
            self.uri = uri
        if greeting is not None:
            self.greeting = greeting
        if formatting_locale is not None:
            self.formatting_locale = formatting_locale
        if locale_code is not None:
            self.locale_code = locale_code
        if iso_code is not None:
            self.iso_code = iso_code
        if name is not None:
            self.name = name
        if ui is not None:
            self.ui = ui
        if time_format is not None:
            self.time_format = time_format
        if date_format is not None:
            self.date_format = date_format
