# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .language_info import LanguageInfo
from .page_navigation_model import PageNavigationModel
from .enumerated_paging_model import EnumeratedPagingModel


@JsonMap({})
class LanguageList(BaseModel):
    """LanguageList

    :param uri: Canonical URI of the language list resource, defaults to None
    :type uri: str, optional
    :param records: Language data, defaults to None
    :type records: List[LanguageInfo], optional
    :param navigation: Links to other pages of the current result set, defaults to None
    :type navigation: PageNavigationModel, optional
    :param paging: paging, defaults to None
    :type paging: EnumeratedPagingModel, optional
    """

    def __init__(
        self,
        uri: str = None,
        records: List[LanguageInfo] = None,
        navigation: PageNavigationModel = None,
        paging: EnumeratedPagingModel = None,
    ):
        if uri is not None:
            self.uri = uri
        if records is not None:
            self.records = self._define_list(records, LanguageInfo)
        if navigation is not None:
            self.navigation = self._define_object(navigation, PageNavigationModel)
        if paging is not None:
            self.paging = self._define_object(paging, EnumeratedPagingModel)
