# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .message_attachment_type_enum import MessageAttachmentTypeEnum


@JsonMap(
    {
        "id_": "id",
        "type_": "type",
        "content_type": "contentType",
        "vm_duration": "vmDuration",
        "file_name": "fileName",
    }
)
class MessageAttachmentInfo(BaseModel):
    """MessageAttachmentInfo

    :param id_: Internal identifier of a message attachment, defaults to None
    :type id_: int, optional
    :param uri: Canonical URI of a message attachment, defaults to None
    :type uri: str, optional
    :param type_: Type of message attachment, defaults to None
    :type type_: MessageAttachmentTypeEnum, optional
    :param content_type: MIME type for a given attachment, for instance 'audio/wav', defaults to None
    :type content_type: str, optional
    :param vm_duration: Supported for `Voicemail` only. Duration of a voicemail in<br>seconds<br>, defaults to None
    :type vm_duration: int, optional
    :param file_name: Name of a file attached, defaults to None
    :type file_name: str, optional
    :param size: Size of attachment in bytes, defaults to None
    :type size: int, optional
    :param height: Attachment height in pixels if available, defaults to None
    :type height: int, optional
    :param width: Attachment width in pixels if available, defaults to None
    :type width: int, optional
    """

    def __init__(
        self,
        id_: int = None,
        uri: str = None,
        type_: MessageAttachmentTypeEnum = None,
        content_type: str = None,
        vm_duration: int = None,
        file_name: str = None,
        size: int = None,
        height: int = None,
        width: int = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if uri is not None:
            self.uri = uri
        if type_ is not None:
            self.type_ = self._enum_matching(
                type_, MessageAttachmentTypeEnum.list(), "type_"
            )
        if content_type is not None:
            self.content_type = content_type
        if vm_duration is not None:
            self.vm_duration = vm_duration
        if file_name is not None:
            self.file_name = file_name
        if size is not None:
            self.size = size
        if height is not None:
            self.height = height
        if width is not None:
            self.width = width
