# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"phone_number": "phoneNumber"})
class MissedCallExtensionInfoExternalNumber(BaseModel):
    """Specifies an external PSTN number which should be used for the missed call transfer. Returned only if the actionType is set to `ConnectToExternalNumber`

    :param phone_number: Phone number to which the call is forwarded. In addition to common [E.164](https://www.itu.int/rec/T-REC-E.164-201011-I) format, the following number patterns are supported: 11xxxxxxxxxxx, 444xxxxxxxxxxx, 616xxxxxxxxxxx, 1700yyyy; where `xxxxxxxxxxx` is a phone number in e.164 format (without '+' sign) and `yyyy` is an external short extension number. Maximum number of digits is 15, defaults to None
    :type phone_number: str, optional
    """

    def __init__(self, phone_number: str = None):
        if phone_number is not None:
            self.phone_number = phone_number
