# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .automatic_location_updates_site_info import AutomaticLocationUpdatesSiteInfo
from .public_ip_range_info import PublicIpRangeInfo
from .private_ip_range_info import PrivateIpRangeInfo


@JsonMap(
    {
        "id_": "id",
        "public_ip_ranges": "publicIpRanges",
        "private_ip_ranges": "privateIpRanges",
    }
)
class NetworkInfo(BaseModel):
    """NetworkInfo

    :param id_: Internal identifier of a network, defaults to None
    :type id_: str, optional
    :param uri: Link to a network resource, defaults to None
    :type uri: str, optional
    :param name: name, defaults to None
    :type name: str, optional
    :param site: Site data. If multi-site feature is turned on for the account,<br>then ID of a site must be specified. In order to assign a wireless<br>point to the main site (company) site ID should be set to `main-site`<br>, defaults to None
    :type site: AutomaticLocationUpdatesSiteInfo, optional
    :param public_ip_ranges: public_ip_ranges, defaults to None
    :type public_ip_ranges: List[PublicIpRangeInfo], optional
    :param private_ip_ranges: private_ip_ranges, defaults to None
    :type private_ip_ranges: List[PrivateIpRangeInfo], optional
    """

    def __init__(
        self,
        id_: str = None,
        uri: str = None,
        name: str = None,
        site: AutomaticLocationUpdatesSiteInfo = None,
        public_ip_ranges: List[PublicIpRangeInfo] = None,
        private_ip_ranges: List[PrivateIpRangeInfo] = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if uri is not None:
            self.uri = uri
        if name is not None:
            self.name = name
        if site is not None:
            self.site = self._define_object(site, AutomaticLocationUpdatesSiteInfo)
        if public_ip_ranges is not None:
            self.public_ip_ranges = self._define_list(
                public_ip_ranges, PublicIpRangeInfo
            )
        if private_ip_ranges is not None:
            self.private_ip_ranges = self._define_list(
                private_ip_ranges, PrivateIpRangeInfo
            )
