# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "per_page": "perPage",
        "page_token": "pageToken",
        "next_page_token": "nextPageToken",
        "previous_page_token": "previousPageToken",
        "first_page_token": "firstPageToken",
    }
)
class NonEnumeratedPagingModel(BaseModel):
    """NonEnumeratedPagingModel

    :param per_page: Current page size, describes how many items are in each page.<br>Matches "perPage" parameter from the request.<br>
    :type per_page: int
    :param page_token: Current page token. May be omitted if result is empty (because non-existent page<br>was specified or perPage=0 was requested)<br>, defaults to None
    :type page_token: str, optional
    :param next_page_token: A page token to be used to fetch the next page of the result set. May be omitted if the current page is the last one., defaults to None
    :type next_page_token: str, optional
    :param previous_page_token: A page token to be used to fetch the previous page of the result set.<br>May be omitted if the current page is the first one or if the result set does not support backward navigation.<br>, defaults to None
    :type previous_page_token: str, optional
    :param first_page_token: A page token to be used to fetch the first page of the result set., defaults to None
    :type first_page_token: str, optional
    """

    def __init__(
        self,
        per_page: int,
        page_token: str = None,
        next_page_token: str = None,
        previous_page_token: str = None,
        first_page_token: str = None,
    ):
        self.per_page = per_page
        if page_token is not None:
            self.page_token = page_token
        if next_page_token is not None:
            self.next_page_token = next_page_token
        if previous_page_token is not None:
            self.previous_page_token = previous_page_token
        if first_page_token is not None:
            self.first_page_token = first_page_token
