# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .voicemails_info import VoicemailsInfo
from .inbound_faxes_info import InboundFaxesInfo
from .outbound_faxes_info import OutboundFaxesInfo
from .inbound_texts_info import InboundTextsInfo
from .missed_calls_info import MissedCallsInfo


@JsonMap(
    {
        "email_addresses": "emailAddresses",
        "sms_email_addresses": "smsEmailAddresses",
        "advanced_mode": "advancedMode",
        "inbound_faxes": "inboundFaxes",
        "outbound_faxes": "outboundFaxes",
        "inbound_texts": "inboundTexts",
        "missed_calls": "missedCalls",
        "include_managers": "includeManagers",
    }
)
class NotificationSettingsUpdateRequest(BaseModel):
    """NotificationSettingsUpdateRequest

    :param email_addresses: List of notification recipient email addresses. Should not be empty<br>if 'includeManagers' parameter is set to false<br>, defaults to None
    :type email_addresses: List[str], optional
    :param sms_email_addresses: List of notification recipient email addresses, defaults to None
    :type sms_email_addresses: List[str], optional
    :param advanced_mode: Specifies notifications settings mode. If `true` then advanced<br>mode is on, it allows using different emails and/or phone numbers for<br>each notification type. If `false` then basic mode is on. Advanced mode<br>settings are returned in both modes, if specified once, but if basic mode<br>is switched on, they are not applied<br>, defaults to None
    :type advanced_mode: bool, optional
    :param voicemails: voicemails, defaults to None
    :type voicemails: VoicemailsInfo, optional
    :param inbound_faxes: inbound_faxes, defaults to None
    :type inbound_faxes: InboundFaxesInfo, optional
    :param outbound_faxes: outbound_faxes, defaults to None
    :type outbound_faxes: OutboundFaxesInfo, optional
    :param inbound_texts: inbound_texts, defaults to None
    :type inbound_texts: InboundTextsInfo, optional
    :param missed_calls: missed_calls, defaults to None
    :type missed_calls: MissedCallsInfo, optional
    :param include_managers: Specifies if managers' emails are included in the list of emails to<br>which notifications are sent. If not specified, then the value is `true`<br>, defaults to None
    :type include_managers: bool, optional
    """

    def __init__(
        self,
        email_addresses: List[str] = None,
        sms_email_addresses: List[str] = None,
        advanced_mode: bool = None,
        voicemails: VoicemailsInfo = None,
        inbound_faxes: InboundFaxesInfo = None,
        outbound_faxes: OutboundFaxesInfo = None,
        inbound_texts: InboundTextsInfo = None,
        missed_calls: MissedCallsInfo = None,
        include_managers: bool = None,
    ):
        if email_addresses is not None:
            self.email_addresses = email_addresses
        if sms_email_addresses is not None:
            self.sms_email_addresses = sms_email_addresses
        if advanced_mode is not None:
            self.advanced_mode = advanced_mode
        if voicemails is not None:
            self.voicemails = self._define_object(voicemails, VoicemailsInfo)
        if inbound_faxes is not None:
            self.inbound_faxes = self._define_object(inbound_faxes, InboundFaxesInfo)
        if outbound_faxes is not None:
            self.outbound_faxes = self._define_object(outbound_faxes, OutboundFaxesInfo)
        if inbound_texts is not None:
            self.inbound_texts = self._define_object(inbound_texts, InboundTextsInfo)
        if missed_calls is not None:
            self.missed_calls = self._define_object(missed_calls, MissedCallsInfo)
        if include_managers is not None:
            self.include_managers = include_managers
