# This file was generated by liblab | https://liblab.com/

from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({"from_": "from", "opt_outs": "optOuts", "opt_ins": "optIns"})
class OptOutBulkAssignRequest(BaseModel):
    """Consists of `from` field and `optOuts` and `optIns` lists. Both `optOuts` and `optIns` can be empty but not simultaneously - at least one of the lists must be entered."

    :param from_: The phone number of a sender which the recipients should be opted out from or opted in to
    :type from_: str
    :param opt_outs: The list of phone numbers to be opted out, defaults to None
    :type opt_outs: List[str], optional
    :param opt_ins: The list of phone numbers to be opted in, defaults to None
    :type opt_ins: List[str], optional
    """

    def __init__(
        self, from_: str, opt_outs: List[str] = None, opt_ins: List[str] = None
    ):
        self.from_ = from_
        if opt_outs is not None:
            self.opt_outs = opt_outs
        if opt_ins is not None:
            self.opt_ins = opt_ins
