# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .get_country_info_number_parser import GetCountryInfoNumberParser
from .phone_number_info_number_parser import PhoneNumberInfoNumberParser


@JsonMap({"home_country": "homeCountry", "phone_numbers": "phoneNumbers"})
class ParsePhoneNumberResponse(BaseModel):
    """ParsePhoneNumberResponse

    :param uri: Canonical URI of a resource, defaults to None
    :type uri: str, optional
    :param home_country: home_country
    :type home_country: GetCountryInfoNumberParser
    :param phone_numbers: Parsed phone numbers information
    :type phone_numbers: List[PhoneNumberInfoNumberParser]
    """

    def __init__(
        self,
        home_country: GetCountryInfoNumberParser,
        phone_numbers: List[PhoneNumberInfoNumberParser],
        uri: str = None,
    ):
        if uri is not None:
            self.uri = uri
        self.home_country = self._define_object(
            home_country, GetCountryInfoNumberParser
        )
        self.phone_numbers = self._define_list(
            phone_numbers, PhoneNumberInfoNumberParser
        )
