# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel
from .rcw_role_enum import RcwRoleEnum
from .rcw_domain_user_model import RcwDomainUserModel


class ParticipantExtendedModelType(Enum):
    """An enumeration representing different categories.

    :cvar USER: "User"
    :vartype USER: str
    :cvar ROOM: "Room"
    :vartype ROOM: str
    """

    USER = "User"
    ROOM = "Room"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, ParticipantExtendedModelType._member_map_.values())
        )


@JsonMap(
    {
        "id_": "id",
        "first_name": "firstName",
        "last_name": "lastName",
        "original_role": "originalRole",
        "linked_user": "linkedUser",
        "avatar_token": "avatarToken",
        "type_": "type",
        "qna_blocked": "qnaBlocked",
        "join_time": "joinTime",
        "leave_time": "leaveTime",
        "was_ejected": "wasEjected",
        "invitee_id": "inviteeId",
        "registrant_id": "registrantId",
        "unique_user_hash": "uniqueUserHash",
    }
)
class ParticipantExtendedModel(BaseModel):
    """ParticipantExtendedModel

    :param id_: Internal object ID, defaults to None
    :type id_: str, optional
    :param first_name: First (given) name, defaults to None
    :type first_name: str, optional
    :param last_name: Last (family) name, defaults to None
    :type last_name: str, optional
    :param role: The role of the webinar session participant/invitee.<br>See also: [Understanding Webinar Roles](https://support.ringcentral.com/webinar/getting-started/understanding-ringcentral-webinar-roles.html)<br>
    :type role: RcwRoleEnum
    :param original_role: The role of the webinar session participant/invitee.<br>See also: [Understanding Webinar Roles](https://support.ringcentral.com/webinar/getting-started/understanding-ringcentral-webinar-roles.html)<br>
    :type original_role: RcwRoleEnum
    :param linked_user: linked_user, defaults to None
    :type linked_user: RcwDomainUserModel, optional
    :param avatar_token: A token to access avatar image from CDN. Available only for authenticated panelists, defaults to None
    :type avatar_token: str, optional
    :param type_: The type of the participant specified in invite or determined at join time
    :type type_: ParticipantExtendedModelType
    :param email: User's contact email, defaults to None
    :type email: str, optional
    :param qna_blocked: Boolean to indicate if the participant was blocked from Q&A<br>, defaults to None
    :type qna_blocked: bool, optional
    :param join_time: The time (earliest) when this participant joined the session, defaults to None
    :type join_time: str, optional
    :param leave_time: The time (latest) when this participant left the session, defaults to None
    :type leave_time: str, optional
    :param was_ejected: Indicates if this participant was ejected from the webinar, defaults to None
    :type was_ejected: bool, optional
    :param invitee_id: For invited participants - Invitee ID (matches Configuration API Invitee IDs), defaults to None
    :type invitee_id: str, optional
    :param registrant_id: Registrant ID, defaults to None
    :type registrant_id: str, optional
    :param unique_user_hash: The hash string which is unique for each unique user, defaults to None
    :type unique_user_hash: str, optional
    """

    def __init__(
        self,
        role: RcwRoleEnum,
        original_role: RcwRoleEnum,
        type_: ParticipantExtendedModelType,
        id_: str = None,
        first_name: str = None,
        last_name: str = None,
        linked_user: RcwDomainUserModel = None,
        avatar_token: str = None,
        email: str = None,
        qna_blocked: bool = None,
        join_time: str = None,
        leave_time: str = None,
        was_ejected: bool = None,
        invitee_id: str = None,
        registrant_id: str = None,
        unique_user_hash: str = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        self.role = self._enum_matching(role, RcwRoleEnum.list(), "role")
        self.original_role = self._enum_matching(
            original_role, RcwRoleEnum.list(), "original_role"
        )
        if linked_user is not None:
            self.linked_user = self._define_object(linked_user, RcwDomainUserModel)
        if avatar_token is not None:
            self.avatar_token = avatar_token
        self.type_ = self._enum_matching(
            type_, ParticipantExtendedModelType.list(), "type_"
        )
        if email is not None:
            self.email = email
        if qna_blocked is not None:
            self.qna_blocked = qna_blocked
        if join_time is not None:
            self.join_time = join_time
        if leave_time is not None:
            self.leave_time = leave_time
        if was_ejected is not None:
            self.was_ejected = was_ejected
        if invitee_id is not None:
            self.invitee_id = invitee_id
        if registrant_id is not None:
            self.registrant_id = registrant_id
        if unique_user_hash is not None:
            self.unique_user_hash = unique_user_hash
