# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({})
class PostalAddress(BaseModel):
    """Postal address/location

    :param street: Street address
    :type street: str
    :param street2: Street address (2nd line), defaults to None
    :type street2: str, optional
    :param city: City name
    :type city: str
    :param state: State or province information in the target country, defaults to None
    :type state: str, optional
    :param zip: Postal code in the target country
    :type zip: str
    :param country: ISO-3166-1 2-letter country code (alpha2)
    :type country: str
    """

    def __init__(
        self,
        street: str,
        city: str,
        zip: str,
        country: str,
        street2: str = None,
        state: str = None,
    ):
        self.street = street
        if street2 is not None:
            self.street2 = street2
        self.city = city
        if state is not None:
            self.state = state
        self.zip = zip
        self.country = country
