# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "per_page": "perPage",
        "page_token": "pageToken",
        "next_page_token": "nextPageToken",
        "previous_page_token": "previousPageToken",
    }
)
class RcwPagingModel(BaseModel):
    """RcwPagingModel

    :param per_page: Number of items per page
    :type per_page: int
    :param page_token: Current page token
    :type page_token: str
    :param next_page_token: Next page token (absent for the last page of the result set), defaults to None
    :type next_page_token: str, optional
    :param previous_page_token: Previous page token (absent for the first page of the result set), defaults to None
    :type previous_page_token: str, optional
    """

    def __init__(
        self,
        per_page: int,
        page_token: str,
        next_page_token: str = None,
        previous_page_token: str = None,
    ):
        self.per_page = per_page
        self.page_token = page_token
        if next_page_token is not None:
            self.next_page_token = next_page_token
        if previous_page_token is not None:
            self.previous_page_token = previous_page_token
