# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel
from .call_status_info import CallStatusInfo
from .park_info import ParkInfo
from .party_info import PartyInfo
from .owner_info import OwnerInfo


class ReplyPartyDirection(Enum):
    """An enumeration representing different categories.

    :cvar INBOUND: "Inbound"
    :vartype INBOUND: str
    :cvar OUTBOUND: "Outbound"
    :vartype OUTBOUND: str
    """

    INBOUND = "Inbound"
    OUTBOUND = "Outbound"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, ReplyPartyDirection._member_map_.values()))


@JsonMap({"id_": "id", "stand_alone": "standAlone", "from_": "from"})
class ReplyParty(BaseModel):
    """ReplyParty

    :param id_: Internal identifier of a party, defaults to None
    :type id_: str, optional
    :param status: Status data of a call session, defaults to None
    :type status: CallStatusInfo, optional
    :param muted: Specifies if a call participant is muted or not. **Note:** If a call is also controlled via Hard phone or RingCentral App (not only through the API by calling call control methods) then it cannot be fully muted/unmuted via API only, in this case the action should be duplicated via Hard phone/RC App interfaces, defaults to None
    :type muted: bool, optional
    :param stand_alone: If `true` then the party is not connected to a session voice conference, `false` means the party is connected to other parties in a session, defaults to None
    :type stand_alone: bool, optional
    :param park: Call park information, defaults to None
    :type park: ParkInfo, optional
    :param from_: from_, defaults to None
    :type from_: PartyInfo, optional
    :param to: to, defaults to None
    :type to: PartyInfo, optional
    :param owner: Deprecated. Information on a call owner, defaults to None
    :type owner: OwnerInfo, optional
    :param direction: Direction of a call, defaults to None
    :type direction: ReplyPartyDirection, optional
    """

    def __init__(
        self,
        id_: str = None,
        status: CallStatusInfo = None,
        muted: bool = None,
        stand_alone: bool = None,
        park: ParkInfo = None,
        from_: PartyInfo = None,
        to: PartyInfo = None,
        owner: OwnerInfo = None,
        direction: ReplyPartyDirection = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if status is not None:
            self.status = self._define_object(status, CallStatusInfo)
        if muted is not None:
            self.muted = muted
        if stand_alone is not None:
            self.stand_alone = stand_alone
        if park is not None:
            self.park = self._define_object(park, ParkInfo)
        if from_ is not None:
            self.from_ = self._define_object(from_, PartyInfo)
        if to is not None:
            self.to = self._define_object(to, PartyInfo)
        if owner is not None:
            self.owner = self._define_object(owner, OwnerInfo)
        if direction is not None:
            self.direction = self._enum_matching(
                direction, ReplyPartyDirection.list(), "direction"
            )
