# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .billing_plan_info import BillingPlanInfo
from .brand_info import BrandInfo
from .service_plan_info import ServicePlanInfo
from .target_service_plan_info import TargetServicePlanInfo
from .country_info_short_model import CountryInfoShortModel
from .u_brand_info import UBrandInfo


@JsonMap(
    {
        "billing_plan": "billingPlan",
        "service_plan": "servicePlan",
        "target_service_plan": "targetServicePlan",
        "contracted_country": "contractedCountry",
        "u_brand": "uBrand",
    }
)
class ServiceInfo(BaseModel):
    """Account service information, including brand, sub-brand, service plan and
    billing plan


    :param uri: Canonical URI of a service info resource, defaults to None
    :type uri: str, optional
    :param billing_plan: Information on account billing plan, defaults to None
    :type billing_plan: BillingPlanInfo, optional
    :param brand: Information on account brand, defaults to None
    :type brand: BrandInfo, optional
    :param service_plan: Information on account service plan, defaults to None
    :type service_plan: ServicePlanInfo, optional
    :param target_service_plan: Information on account target service plan, defaults to None
    :type target_service_plan: TargetServicePlanInfo, optional
    :param contracted_country: contracted_country, defaults to None
    :type contracted_country: CountryInfoShortModel, optional
    :param u_brand: Account sub-brand information, defaults to None
    :type u_brand: UBrandInfo, optional
    """

    def __init__(
        self,
        uri: str = None,
        billing_plan: BillingPlanInfo = None,
        brand: BrandInfo = None,
        service_plan: ServicePlanInfo = None,
        target_service_plan: TargetServicePlanInfo = None,
        contracted_country: CountryInfoShortModel = None,
        u_brand: UBrandInfo = None,
    ):
        if uri is not None:
            self.uri = uri
        if billing_plan is not None:
            self.billing_plan = self._define_object(billing_plan, BillingPlanInfo)
        if brand is not None:
            self.brand = self._define_object(brand, BrandInfo)
        if service_plan is not None:
            self.service_plan = self._define_object(service_plan, ServicePlanInfo)
        if target_service_plan is not None:
            self.target_service_plan = self._define_object(
                target_service_plan, TargetServicePlanInfo
            )
        if contracted_country is not None:
            self.contracted_country = self._define_object(
                contracted_country, CountryInfoShortModel
            )
        if u_brand is not None:
            self.u_brand = self._define_object(u_brand, UBrandInfo)
