# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


class Version(Enum):
    """An enumeration representing different categories.

    :cvar _1: "1"
    :vartype _1: str
    """

    _1 = "1"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, Version._member_map_.values()))


@JsonMap({"id_": "id"})
class ServiceInfoPackage(BaseModel):
    """Billing package information

    :param id_: Billing package ID
    :type id_: str
    :param version: Billing package version
    :type version: Version
    """

    def __init__(self, id_: str, version: Version):
        self.id_ = id_
        self.version = self._enum_matching(version, Version.list(), "version")
