# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .service_info_package import ServiceInfoPackage
from .service_info_brand import ServiceInfoBrand
from .service_info_country_short_model import ServiceInfoCountryShortModel
from .service_info_u_brand import ServiceInfoUBrand
from .service_info_plan import ServiceInfoPlan


@JsonMap(
    {
        "contracted_country": "contractedCountry",
        "u_brand": "uBrand",
        "service_plan": "servicePlan",
    }
)
class ServiceInfoV2(BaseModel):
    """Service Plan information (billing package, brand, etc.)

    :param package: Billing package information
    :type package: ServiceInfoPackage
    :param brand: Internal RC "brand" information, defaults to None
    :type brand: ServiceInfoBrand, optional
    :param contracted_country: contracted_country, defaults to None
    :type contracted_country: ServiceInfoCountryShortModel, optional
    :param u_brand: Account sub-brand information, defaults to None
    :type u_brand: ServiceInfoUBrand, optional
    :param service_plan: Information on account service plan, defaults to None
    :type service_plan: ServiceInfoPlan, optional
    """

    def __init__(
        self,
        package: ServiceInfoPackage,
        brand: ServiceInfoBrand = None,
        contracted_country: ServiceInfoCountryShortModel = None,
        u_brand: ServiceInfoUBrand = None,
        service_plan: ServiceInfoPlan = None,
    ):
        self.package = self._define_object(package, ServiceInfoPackage)
        if brand is not None:
            self.brand = self._define_object(brand, ServiceInfoBrand)
        if contracted_country is not None:
            self.contracted_country = self._define_object(
                contracted_country, ServiceInfoCountryShortModel
            )
        if u_brand is not None:
            self.u_brand = self._define_object(u_brand, ServiceInfoUBrand)
        if service_plan is not None:
            self.service_plan = self._define_object(service_plan, ServiceInfoPlan)
