# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel
from .site_ivr_actions_extension_info import SiteIvrActionsExtensionInfo


class SiteIvrActionsInput(Enum):
    """An enumeration representing different categories.

    :cvar STAR: "Star"
    :vartype STAR: str
    :cvar HASH: "Hash"
    :vartype HASH: str
    :cvar NOINPUT: "NoInput"
    :vartype NOINPUT: str
    """

    STAR = "Star"
    HASH = "Hash"
    NOINPUT = "NoInput"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, SiteIvrActionsInput._member_map_.values()))


class SiteIvrActionsAction(Enum):
    """An enumeration representing different categories.

    :cvar REPEAT: "Repeat"
    :vartype REPEAT: str
    :cvar RETURNTOROOT: "ReturnToRoot"
    :vartype RETURNTOROOT: str
    :cvar RETURNTOPREVIOUS: "ReturnToPrevious"
    :vartype RETURNTOPREVIOUS: str
    :cvar RETURNTOTOPLEVELMENU: "ReturnToTopLevelMenu"
    :vartype RETURNTOTOPLEVELMENU: str
    :cvar CONNECT: "Connect"
    :vartype CONNECT: str
    :cvar DISCONNECT: "Disconnect"
    :vartype DISCONNECT: str
    :cvar DONOTHING: "DoNothing"
    :vartype DONOTHING: str
    """

    REPEAT = "Repeat"
    RETURNTOROOT = "ReturnToRoot"
    RETURNTOPREVIOUS = "ReturnToPrevious"
    RETURNTOTOPLEVELMENU = "ReturnToTopLevelMenu"
    CONNECT = "Connect"
    DISCONNECT = "Disconnect"
    DONOTHING = "DoNothing"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, SiteIvrActionsAction._member_map_.values()))


@JsonMap({})
class SiteIvrActions(BaseModel):
    """Keys handling settings

    :param input: input, defaults to None
    :type input: SiteIvrActionsInput, optional
    :param action: Key handling action:<br>- Repeat - repeat menu greeting, for Star and Hash only;<br>- ReturnToRoot - return to root IVR menu, for Star and Hash only;<br>- ReturnToPrevious - return to previous IVR menu, for Star and Hash only;<br>- Connect - connect to specific extension, for NoInput only;<br>- Disconnect - end call, for NoInput only.<br>, defaults to None
    :type action: SiteIvrActionsAction, optional
    :param extension: Extension information, defaults to None
    :type extension: SiteIvrActionsExtensionInfo, optional
    """

    def __init__(
        self,
        input: SiteIvrActionsInput = None,
        action: SiteIvrActionsAction = None,
        extension: SiteIvrActionsExtensionInfo = None,
    ):
        if input is not None:
            self.input = self._enum_matching(input, SiteIvrActionsInput.list(), "input")
        if action is not None:
            self.action = self._enum_matching(
                action, SiteIvrActionsAction.list(), "action"
            )
        if extension is not None:
            self.extension = self._define_object(extension, SiteIvrActionsExtensionInfo)
