# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .contact_business_address_info import ContactBusinessAddressInfo
from .regional_settings import RegionalSettings
from .operator_info import OperatorInfo


@JsonMap(
    {
        "extension_number": "extensionNumber",
        "caller_id_name": "callerIdName",
        "business_address": "businessAddress",
        "regional_settings": "regionalSettings",
    }
)
class SiteUpdateRequest(BaseModel):
    """SiteUpdateRequest

    :param name: Extension user first name
    :type name: str
    :param extension_number: Extension number, defaults to None
    :type extension_number: str, optional
    :param caller_id_name: Custom name of a caller. Max number of characters is 15 (only<br>alphabetical symbols, numbers and commas are supported)<br>, defaults to None
    :type caller_id_name: str, optional
    :param email: Site extension contact email, defaults to None
    :type email: str, optional
    :param business_address: User's business address. The default is<br>Company (Auto-Receptionist) settings<br>, defaults to None
    :type business_address: ContactBusinessAddressInfo, optional
    :param regional_settings: Regional data (timezone, home country, language) of an extension/account.<br>The default is Company (Auto-Receptionist) settings<br>, defaults to None
    :type regional_settings: RegionalSettings, optional
    :param operator: Site Fax/SMS recipient (operator) reference. Multi-level IVR should<br>be enabled<br>, defaults to None
    :type operator: OperatorInfo, optional
    """

    def __init__(
        self,
        name: str,
        extension_number: str = None,
        caller_id_name: str = None,
        email: str = None,
        business_address: ContactBusinessAddressInfo = None,
        regional_settings: RegionalSettings = None,
        operator: OperatorInfo = None,
    ):
        self.name = name
        if extension_number is not None:
            self.extension_number = extension_number
        if caller_id_name is not None:
            self.caller_id_name = caller_id_name
        if email is not None:
            self.email = email
        if business_address is not None:
            self.business_address = self._define_object(
                business_address, ContactBusinessAddressInfo
            )
        if regional_settings is not None:
            self.regional_settings = self._define_object(
                regional_settings, RegionalSettings
            )
        if operator is not None:
            self.operator = self._define_object(operator, OperatorInfo)
