# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .global_dial_in_country_response import GlobalDialInCountryResponse


@JsonMap(
    {
        "third_party_audio": "thirdPartyAudio",
        "audio_conference_info": "audioConferenceInfo",
        "global_dial_countries": "globalDialCountries",
    }
)
class TelephonyUserMeetingSettings(BaseModel):
    """TelephonyUserMeetingSettings

    :param third_party_audio: ThirdParty audio option, defaults to None
    :type third_party_audio: bool, optional
    :param audio_conference_info: Users can join the meeting using the existing 3rd party audio configuration, defaults to None
    :type audio_conference_info: bool, optional
    :param global_dial_countries: global_dial_countries, defaults to None
    :type global_dial_countries: List[GlobalDialInCountryResponse], optional
    """

    def __init__(
        self,
        third_party_audio: bool = None,
        audio_conference_info: bool = None,
        global_dial_countries: List[GlobalDialInCountryResponse] = None,
    ):
        if third_party_audio is not None:
            self.third_party_audio = third_party_audio
        if audio_conference_info is not None:
            self.audio_conference_info = audio_conference_info
        if global_dial_countries is not None:
            self.global_dial_countries = self._define_list(
                global_dial_countries, GlobalDialInCountryResponse
            )
