# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .grouping import Grouping, GroupingGuard
from .direct_grouping import DirectGrouping
from .grouping_by_members import GroupingByMembers
from .time_settings import TimeSettings
from .call_filters import CallFilters
from .timeline_response_options import TimelineResponseOptions


@JsonMap(
    {
        "time_settings": "timeSettings",
        "call_filters": "callFilters",
        "response_options": "responseOptions",
    }
)
class TimelineRequest(BaseModel):
    """TimelineRequest

    :param grouping: This field specifies the dimensions by which the response should be grouped and specific keys to narrow the response. See also [Call Aggregate reports](https://developers.ringcentral.com/guide/analytics/aggregate) or [Call Timeline reports](https://developers.ringcentral.com/guide/analytics/timeline) pages in the developer guide for more information
    :type grouping: Grouping
    :param time_settings: Date-time range for the calls. The call is considered to be within time range if it started within time range. Both borders are inclusive
    :type time_settings: TimeSettings
    :param call_filters: Optional filters that limit the scope of calls (joined via AND), defaults to None
    :type call_filters: CallFilters, optional
    :param response_options: Counters and timers options for calls breakdown
    :type response_options: TimelineResponseOptions
    """

    def __init__(
        self,
        grouping: Grouping,
        time_settings: TimeSettings,
        response_options: TimelineResponseOptions,
        call_filters: CallFilters = None,
    ):
        self.grouping = GroupingGuard.return_one_of(grouping)
        self.time_settings = self._define_object(time_settings, TimeSettings)
        if call_filters is not None:
            self.call_filters = self._define_object(call_filters, CallFilters)
        self.response_options = self._define_object(
            response_options, TimelineResponseOptions
        )
