# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .grouping_options import GroupingOptions
from .timeline_response_record import TimelineResponseRecord


@JsonMap({"grouped_by": "groupedBy"})
class TimelineResponseData(BaseModel):
    """A list of time-value points of call data as per the grouping and filtering options specified in the request

    :param grouped_by: The selected grouping option
    :type grouped_by: GroupingOptions
    :param records: List of call data as per the grouping and filtering options specified in the request, defaults to None
    :type records: List[TimelineResponseRecord], optional
    """

    def __init__(
        self, grouped_by: GroupingOptions, records: List[TimelineResponseRecord] = None
    ):
        self.grouped_by = self._enum_matching(
            grouped_by, GroupingOptions.list(), "grouped_by"
        )
        if records is not None:
            self.records = self._define_list(records, TimelineResponseRecord)
