# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "id_": "id",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class TmCompanyInfo(BaseModel):
    """TmCompanyInfo

    :param id_: Internal identifier of a company (RingCentral account ID)
    :type id_: str
    :param name: Name of a company, defaults to None
    :type name: str, optional
    :param domain: Domain name of a company, defaults to None
    :type domain: str, optional
    :param creation_time: Datetime of creation in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601)
    :type creation_time: str
    :param last_modified_time: Datetime of last modification in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601)
    :type last_modified_time: str
    """

    def __init__(
        self,
        id_: str,
        creation_time: str,
        last_modified_time: str,
        name: str = None,
        domain: str = None,
    ):
        self.id_ = id_
        if name is not None:
            self.name = name
        if domain is not None:
            self.domain = domain
        self.creation_time = creation_time
        self.last_modified_time = last_modified_time
