# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .tm_chat_member_info import TmChatMemberInfo


class TmConversationInfoType(Enum):
    """An enumeration representing different categories.

    :cvar DIRECT: "Direct"
    :vartype DIRECT: str
    :cvar PERSONAL: "Personal"
    :vartype PERSONAL: str
    :cvar GROUP: "Group"
    :vartype GROUP: str
    """

    DIRECT = "Direct"
    PERSONAL = "Personal"
    GROUP = "Group"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, TmConversationInfoType._member_map_.values())
        )


@JsonMap(
    {
        "id_": "id",
        "type_": "type",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class TmConversationInfo(BaseModel):
    """TmConversationInfo

    :param id_: Internal identifier of a conversation, defaults to None
    :type id_: str, optional
    :param type_: Type of conversation, defaults to None
    :type type_: TmConversationInfoType, optional
    :param creation_time: Conversation creation datetime in ISO 8601 format, defaults to None
    :type creation_time: str, optional
    :param last_modified_time: Conversation last change datetime in ISO 8601 format, defaults to None
    :type last_modified_time: str, optional
    :param members: members, defaults to None
    :type members: List[TmChatMemberInfo], optional
    """

    def __init__(
        self,
        id_: str = None,
        type_: TmConversationInfoType = None,
        creation_time: str = None,
        last_modified_time: str = None,
        members: List[TmChatMemberInfo] = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if type_ is not None:
            self.type_ = self._enum_matching(
                type_, TmConversationInfoType.list(), "type_"
            )
        if creation_time is not None:
            self.creation_time = creation_time
        if last_modified_time is not None:
            self.last_modified_time = last_modified_time
        if members is not None:
            self.members = self._define_list(members, TmChatMemberInfo)
