# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "id_": "id",
        "first_name": "firstName",
        "last_name": "lastName",
        "company_id": "companyId",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class TmPersonInfo(BaseModel):
    """TmPersonInfo

    :param id_: Internal identifier of a user
    :type id_: str
    :param first_name: First name of a user, defaults to None
    :type first_name: str, optional
    :param last_name: Last name of a user, defaults to None
    :type last_name: str, optional
    :param email: Email of a user, defaults to None
    :type email: str, optional
    :param avatar: Photo of a user, defaults to None
    :type avatar: str, optional
    :param company_id: Internal identifier of a company, defaults to None
    :type company_id: str, optional
    :param creation_time: Time of creation in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format, defaults to None
    :type creation_time: str, optional
    :param last_modified_time: Time of the last modification in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format, defaults to None
    :type last_modified_time: str, optional
    """

    def __init__(
        self,
        id_: str,
        first_name: str = None,
        last_name: str = None,
        email: str = None,
        avatar: str = None,
        company_id: str = None,
        creation_time: str = None,
        last_modified_time: str = None,
    ):
        self.id_ = id_
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if email is not None:
            self.email = email
        if avatar is not None:
            self.avatar = avatar
        if company_id is not None:
            self.company_id = company_id
        if creation_time is not None:
            self.creation_time = creation_time
        if last_modified_time is not None:
            self.last_modified_time = last_modified_time
