# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap(
    {
        "phone_number": "phoneNumber",
        "park_orbit": "parkOrbit",
        "extension_number": "extensionNumber",
    }
)
class TransferTarget(BaseModel):
    """Identifier of a call party the call will be transferred to. Only **one of** these parameters: `phoneNumber`, `voicemail`, `extensionNumber` or `parkOrbit` must be specified, otherwise an error is returned.

    :param phone_number: Phone number, defaults to None
    :type phone_number: str, optional
    :param voicemail: Voicemail owner extension identifier, defaults to None
    :type voicemail: str, optional
    :param park_orbit: Park orbit identifier, defaults to None
    :type park_orbit: str, optional
    :param extension_number: Extension short number, defaults to None
    :type extension_number: str, optional
    """

    def __init__(
        self,
        phone_number: str = None,
        voicemail: str = None,
        park_orbit: str = None,
        extension_number: str = None,
    ):
        if phone_number is not None:
            self.phone_number = phone_number
        if voicemail is not None:
            self.voicemail = voicemail
        if park_orbit is not None:
            self.park_orbit = park_orbit
        if extension_number is not None:
            self.extension_number = extension_number
