# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


class UpdateForwardingNumberRequestType(Enum):
    """An enumeration representing different categories.

    :cvar HOME: "Home"
    :vartype HOME: str
    :cvar MOBILE: "Mobile"
    :vartype MOBILE: str
    :cvar WORK: "Work"
    :vartype WORK: str
    :cvar PHONELINE: "PhoneLine"
    :vartype PHONELINE: str
    :cvar OUTAGE: "Outage"
    :vartype OUTAGE: str
    :cvar OTHER: "Other"
    :vartype OTHER: str
    :cvar BUSINESSMOBILEPHONE: "BusinessMobilePhone"
    :vartype BUSINESSMOBILEPHONE: str
    :cvar EXTERNALCARRIER: "ExternalCarrier"
    :vartype EXTERNALCARRIER: str
    """

    HOME = "Home"
    MOBILE = "Mobile"
    WORK = "Work"
    PHONELINE = "PhoneLine"
    OUTAGE = "Outage"
    OTHER = "Other"
    BUSINESSMOBILEPHONE = "BusinessMobilePhone"
    EXTERNALCARRIER = "ExternalCarrier"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                UpdateForwardingNumberRequestType._member_map_.values(),
            )
        )


@JsonMap({"phone_number": "phoneNumber", "flip_number": "flipNumber", "type_": "type"})
class UpdateForwardingNumberRequest(BaseModel):
    """UpdateForwardingNumberRequest

    :param phone_number: Forwarding/Call flip phone number, defaults to None
    :type phone_number: str, optional
    :param label: Forwarding/Call flip number title, defaults to None
    :type label: str, optional
    :param flip_number: Number assigned to the call flip phone number, corresponds to the shortcut dial number, defaults to None
    :type flip_number: str, optional
    :param type_: Forwarding phone number type, defaults to None
    :type type_: UpdateForwardingNumberRequestType, optional
    """

    def __init__(
        self,
        phone_number: str = None,
        label: str = None,
        flip_number: str = None,
        type_: UpdateForwardingNumberRequestType = None,
    ):
        if phone_number is not None:
            self.phone_number = phone_number
        if label is not None:
            self.label = label
        if flip_number is not None:
            self.flip_number = flip_number
        if type_ is not None:
            self.type_ = self._enum_matching(
                type_, UpdateForwardingNumberRequestType.list(), "type_"
            )
