# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .emergency_address_auto_update_site_info import EmergencyAddressAutoUpdateSiteInfo
from .emergency_address_info import EmergencyAddressInfo, EmergencyAddressInfoGuard


@JsonMap({"id_": "id", "emergency_address": "emergencyAddress"})
class UpdateWirelessPoint(BaseModel):
    """UpdateWirelessPoint

    :param id_: Internal identifier of a wireless point, defaults to None
    :type id_: str, optional
    :param bssid: Unique 48-bit identifier of wireless access point that follows<br>MAC address conventions. Mask: XX:XX:XX:XX:XX:XX, where X can be a symbol<br>in the range of 0-9 or A-F<br>, defaults to None
    :type bssid: str, optional
    :param name: Name of a wireless access point, defaults to None
    :type name: str, optional
    :param site: site, defaults to None
    :type site: EmergencyAddressAutoUpdateSiteInfo, optional
    :param emergency_address: emergency_address, defaults to None
    :type emergency_address: EmergencyAddressInfo, optional
    """

    def __init__(
        self,
        id_: str = None,
        bssid: str = None,
        name: str = None,
        site: EmergencyAddressAutoUpdateSiteInfo = None,
        emergency_address: EmergencyAddressInfo = None,
    ):
        if id_ is not None:
            self.id_ = id_
        if bssid is not None:
            self.bssid = bssid
        if name is not None:
            self.name = name
        if site is not None:
            self.site = self._define_object(site, EmergencyAddressAutoUpdateSiteInfo)
        if emergency_address is not None:
            self.emergency_address = EmergencyAddressInfoGuard.return_one_of(
                emergency_address
            )
