# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .wcs_webinar_settings_model import WcsWebinarSettingsModel
from .wcs_host_model import WcsHostModel


@JsonMap(
    {
        "id_": "id",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class WcsWebinarResource(BaseModel):
    """WcsWebinarResource

    :param id_: Internal object ID, defaults to None
    :type id_: str, optional
    :param creation_time: Object creation time
    :type creation_time: str
    :param last_modified_time: Object last modification time
    :type last_modified_time: str
    :param title: Webinar title, defaults to None
    :type title: str, optional
    :param description: User-friendly description of the Webinar, defaults to None
    :type description: str, optional
    :param settings: Various settings which define behavior of this Webinar's Sessions, defaults to None
    :type settings: WcsWebinarSettingsModel, optional
    :param host: host
    :type host: WcsHostModel
    """

    def __init__(
        self,
        creation_time: str,
        last_modified_time: str,
        host: WcsHostModel,
        id_: str = None,
        title: str = None,
        description: str = None,
        settings: WcsWebinarSettingsModel = None,
    ):
        if id_ is not None:
            self.id_ = id_
        self.creation_time = creation_time
        self.last_modified_time = last_modified_time
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if settings is not None:
            self.settings = self._define_object(settings, WcsWebinarSettingsModel)
        self.host = self._define_object(host, WcsHostModel)
