# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .wcs_webinar_settings_model import WcsWebinarSettingsModel
from .rcw_linked_user_model import RcwLinkedUserModel


@JsonMap({})
class WebinarCreationRequest(BaseModel):
    """WebinarCreationRequest

    :param title: Webinar title
    :type title: str
    :param description: User-friendly description of the Webinar, defaults to None
    :type description: str, optional
    :param settings: Various settings which define behavior of this Webinar's Sessions, defaults to None
    :type settings: WcsWebinarSettingsModel, optional
    :param host: The internal IDs of RC-authenticated users., defaults to None
    :type host: RcwLinkedUserModel, optional
    """

    def __init__(
        self,
        title: str,
        description: str = None,
        settings: WcsWebinarSettingsModel = None,
        host: RcwLinkedUserModel = None,
    ):
        self.title = title
        if description is not None:
            self.description = description
        if settings is not None:
            self.settings = self._define_object(settings, WcsWebinarSettingsModel)
        if host is not None:
            self.host = self._define_object(host, RcwLinkedUserModel)
