# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .base import BaseModel
from .webinar_settings_model import WebinarSettingsModel
from .host_model import HostModel


@JsonMap(
    {
        "id_": "id",
        "creation_time": "creationTime",
        "last_modified_time": "lastModifiedTime",
    }
)
class WebinarResource(BaseModel):
    """WebinarResource

    :param id_: Internal object ID, defaults to None
    :type id_: str, optional
    :param creation_time: Object creation time
    :type creation_time: str
    :param last_modified_time: Object last modification time
    :type last_modified_time: str
    :param title: Webinar title
    :type title: str
    :param description: User-friendly description of the Webinar, defaults to None
    :type description: str, optional
    :param settings: Various settings which define behavior of this Webinar's Sessions, defaults to None
    :type settings: WebinarSettingsModel, optional
    :param host: host
    :type host: HostModel
    """

    def __init__(
        self,
        creation_time: str,
        last_modified_time: str,
        title: str,
        host: HostModel,
        id_: str = None,
        description: str = None,
        settings: WebinarSettingsModel = None,
    ):
        if id_ is not None:
            self.id_ = id_
        self.creation_time = creation_time
        self.last_modified_time = last_modified_time
        self.title = title
        if description is not None:
            self.description = description
        if settings is not None:
            self.settings = self._define_object(settings, WebinarSettingsModel)
        self.host = self._define_object(host, HostModel)
