# This file was generated by liblab | https://liblab.com/

from .services.webinar_subscriptions import WebinarSubscriptionsService
from .services.historical_webinars import HistoricalWebinarsService
from .services.historical_recordings import HistoricalRecordingsService
from .services.registration_management import RegistrationManagementService
from .services.registrants import RegistrantsService
from .services.webinars_and_sessions import WebinarsAndSessionsService
from .services.invitees import InviteesService
from .services.call_recordings import CallRecordingsService
from .services.greetings import GreetingsService
from .services.user_settings import UserSettingsService
from .services.message_store import MessageStoreService
from .services.ivr import IvrService
from .services.bridge_management import BridgeManagementService
from .services.meeting_recordings import MeetingRecordingsService
from .services.delegation_management import DelegationManagementService
from .services.meetings_history import MeetingsHistoryService
from .services.api_info import ApiInfoService
from .services.o_auth_2_0_open_id_connect import OAuth2_0OpenIdConnectService
from .services.company import CompanyService
from .services.devices import DevicesService
from .services.phone_numbers import PhoneNumbersService
from .services.business_hours import BusinessHoursService
from .services.custom_fields import CustomFieldsService
from .services.call_recording_settings import CallRecordingSettingsService
from .services.call_control import CallControlService
from .services.sms_templates import SmsTemplatesService
from .services.call_log import CallLogService
from .services.extensions import ExtensionsService
from .services.high_volume_sms import HighVolumeSmsService
from .services.call_handling_rules import CallHandlingRulesService
from .services.external_contacts import ExternalContactsService
from .services.call_queues import CallQueuesService
from .services.presence import PresenceService
from .services.automatic_location_updates import AutomaticLocationUpdatesService
from .services.rcm_meetings_legacy import RcmMeetingsLegacyService
from .services.role_management import RoleManagementService
from .services.call_monitoring_groups import CallMonitoringGroupsService
from .services.audit_trail import AuditTrailService
from .services.message_exports import MessageExportsService
from .services.internal_contacts import InternalContactsService
from .services.paging_only_groups import PagingOnlyGroupsService
from .services.multi_site import MultiSiteService
from .services.video_configuration import VideoConfigurationService
from .services.pager_messages import PagerMessagesService
from .services.user_permissions import UserPermissionsService
from .services.call_forwarding import CallForwardingService
from .services.fax import FaxService
from .services.ring_out import RingOutService
from .services.site_administration import SiteAdministrationService
from .services.sms import SmsService
from .services.features import FeaturesService
from .services.call_blocking import CallBlockingService
from .services.subscriptions import SubscriptionsService
from .services.regional_settings import RegionalSettingsService
from .services.device_sip_registration import DeviceSipRegistrationService
from .services.status import StatusService
from .services.text import TextService
from .services.audio import AudioService
from .services.insights import InsightsService
from .services.contents import ContentsService
from .services.identities import IdentitiesService
from .services.scim import ScimService
from .services.business_analytics import BusinessAnalyticsService
from .services.tasks import TasksService
from .services.calendar_events import CalendarEventsService
from .services.chats import ChatsService
from .services.posts import PostsService
from .services.adaptive_cards import AdaptiveCardsService
from .services.notes import NotesService
from .services.incoming_webhooks import IncomingWebhooksService
from .services.profile import ProfileService
from .services.conversations import ConversationsService
from .services.compliance_exports import ComplianceExportsService
from .services.teams import TeamsService
from .net.environment import Environment


class RingCentral:
    def __init__(
        self, access_token: str = None, base_url: str = Environment.DEFAULT.value
    ):
        """
        Initializes RingCentral the SDK class.
        """
        self.webinar_subscriptions = WebinarSubscriptionsService(base_url=base_url)
        self.historical_webinars = HistoricalWebinarsService(base_url=base_url)
        self.historical_recordings = HistoricalRecordingsService(base_url=base_url)
        self.registration_management = RegistrationManagementService(base_url=base_url)
        self.registrants = RegistrantsService(base_url=base_url)
        self.webinars_and_sessions = WebinarsAndSessionsService(base_url=base_url)
        self.invitees = InviteesService(base_url=base_url)
        self.call_recordings = CallRecordingsService(base_url=base_url)
        self.greetings = GreetingsService(base_url=base_url)
        self.user_settings = UserSettingsService(base_url=base_url)
        self.message_store = MessageStoreService(base_url=base_url)
        self.ivr = IvrService(base_url=base_url)
        self.bridge_management = BridgeManagementService(base_url=base_url)
        self.meeting_recordings = MeetingRecordingsService(base_url=base_url)
        self.delegation_management = DelegationManagementService(base_url=base_url)
        self.meetings_history = MeetingsHistoryService(base_url=base_url)
        self.api_info = ApiInfoService(base_url=base_url)
        self.o_auth_2_0_open_id_connect = OAuth2_0OpenIdConnectService(
            base_url=base_url
        )
        self.company = CompanyService(base_url=base_url)
        self.devices = DevicesService(base_url=base_url)
        self.phone_numbers = PhoneNumbersService(base_url=base_url)
        self.business_hours = BusinessHoursService(base_url=base_url)
        self.custom_fields = CustomFieldsService(base_url=base_url)
        self.call_recording_settings = CallRecordingSettingsService(base_url=base_url)
        self.call_control = CallControlService(base_url=base_url)
        self.sms_templates = SmsTemplatesService(base_url=base_url)
        self.call_log = CallLogService(base_url=base_url)
        self.extensions = ExtensionsService(base_url=base_url)
        self.high_volume_sms = HighVolumeSmsService(base_url=base_url)
        self.call_handling_rules = CallHandlingRulesService(base_url=base_url)
        self.external_contacts = ExternalContactsService(base_url=base_url)
        self.call_queues = CallQueuesService(base_url=base_url)
        self.presence = PresenceService(base_url=base_url)
        self.automatic_location_updates = AutomaticLocationUpdatesService(
            base_url=base_url
        )
        self.rcm_meetings_legacy = RcmMeetingsLegacyService(base_url=base_url)
        self.role_management = RoleManagementService(base_url=base_url)
        self.call_monitoring_groups = CallMonitoringGroupsService(base_url=base_url)
        self.audit_trail = AuditTrailService(base_url=base_url)
        self.message_exports = MessageExportsService(base_url=base_url)
        self.internal_contacts = InternalContactsService(base_url=base_url)
        self.paging_only_groups = PagingOnlyGroupsService(base_url=base_url)
        self.multi_site = MultiSiteService(base_url=base_url)
        self.video_configuration = VideoConfigurationService(base_url=base_url)
        self.pager_messages = PagerMessagesService(base_url=base_url)
        self.user_permissions = UserPermissionsService(base_url=base_url)
        self.call_forwarding = CallForwardingService(base_url=base_url)
        self.fax = FaxService(base_url=base_url)
        self.ring_out = RingOutService(base_url=base_url)
        self.site_administration = SiteAdministrationService(base_url=base_url)
        self.sms = SmsService(base_url=base_url)
        self.features = FeaturesService(base_url=base_url)
        self.call_blocking = CallBlockingService(base_url=base_url)
        self.subscriptions = SubscriptionsService(base_url=base_url)
        self.regional_settings = RegionalSettingsService(base_url=base_url)
        self.device_sip_registration = DeviceSipRegistrationService(base_url=base_url)
        self.status = StatusService(base_url=base_url)
        self.text = TextService(base_url=base_url)
        self.audio = AudioService(base_url=base_url)
        self.insights = InsightsService(base_url=base_url)
        self.contents = ContentsService(base_url=base_url)
        self.identities = IdentitiesService(base_url=base_url)
        self.scim = ScimService(base_url=base_url)
        self.business_analytics = BusinessAnalyticsService(base_url=base_url)
        self.tasks = TasksService(base_url=base_url)
        self.calendar_events = CalendarEventsService(base_url=base_url)
        self.chats = ChatsService(base_url=base_url)
        self.posts = PostsService(base_url=base_url)
        self.adaptive_cards = AdaptiveCardsService(base_url=base_url)
        self.notes = NotesService(base_url=base_url)
        self.incoming_webhooks = IncomingWebhooksService(base_url=base_url)
        self.profile = ProfileService(base_url=base_url)
        self.conversations = ConversationsService(base_url=base_url)
        self.compliance_exports = ComplianceExportsService(base_url=base_url)
        self.teams = TeamsService(base_url=base_url)
        self.set_access_token(access_token)

    def set_base_url(self, base_url):
        """
        Sets the base URL for the entire SDK.
        """
        self.webinar_subscriptions.set_base_url(base_url)
        self.historical_webinars.set_base_url(base_url)
        self.historical_recordings.set_base_url(base_url)
        self.registration_management.set_base_url(base_url)
        self.registrants.set_base_url(base_url)
        self.webinars_and_sessions.set_base_url(base_url)
        self.invitees.set_base_url(base_url)
        self.call_recordings.set_base_url(base_url)
        self.greetings.set_base_url(base_url)
        self.user_settings.set_base_url(base_url)
        self.message_store.set_base_url(base_url)
        self.ivr.set_base_url(base_url)
        self.bridge_management.set_base_url(base_url)
        self.meeting_recordings.set_base_url(base_url)
        self.delegation_management.set_base_url(base_url)
        self.meetings_history.set_base_url(base_url)
        self.api_info.set_base_url(base_url)
        self.o_auth_2_0_open_id_connect.set_base_url(base_url)
        self.company.set_base_url(base_url)
        self.devices.set_base_url(base_url)
        self.phone_numbers.set_base_url(base_url)
        self.business_hours.set_base_url(base_url)
        self.custom_fields.set_base_url(base_url)
        self.call_recording_settings.set_base_url(base_url)
        self.call_control.set_base_url(base_url)
        self.sms_templates.set_base_url(base_url)
        self.call_log.set_base_url(base_url)
        self.extensions.set_base_url(base_url)
        self.high_volume_sms.set_base_url(base_url)
        self.call_handling_rules.set_base_url(base_url)
        self.external_contacts.set_base_url(base_url)
        self.call_queues.set_base_url(base_url)
        self.presence.set_base_url(base_url)
        self.automatic_location_updates.set_base_url(base_url)
        self.rcm_meetings_legacy.set_base_url(base_url)
        self.role_management.set_base_url(base_url)
        self.call_monitoring_groups.set_base_url(base_url)
        self.audit_trail.set_base_url(base_url)
        self.message_exports.set_base_url(base_url)
        self.internal_contacts.set_base_url(base_url)
        self.paging_only_groups.set_base_url(base_url)
        self.multi_site.set_base_url(base_url)
        self.video_configuration.set_base_url(base_url)
        self.pager_messages.set_base_url(base_url)
        self.user_permissions.set_base_url(base_url)
        self.call_forwarding.set_base_url(base_url)
        self.fax.set_base_url(base_url)
        self.ring_out.set_base_url(base_url)
        self.site_administration.set_base_url(base_url)
        self.sms.set_base_url(base_url)
        self.features.set_base_url(base_url)
        self.call_blocking.set_base_url(base_url)
        self.subscriptions.set_base_url(base_url)
        self.regional_settings.set_base_url(base_url)
        self.device_sip_registration.set_base_url(base_url)
        self.status.set_base_url(base_url)
        self.text.set_base_url(base_url)
        self.audio.set_base_url(base_url)
        self.insights.set_base_url(base_url)
        self.contents.set_base_url(base_url)
        self.identities.set_base_url(base_url)
        self.scim.set_base_url(base_url)
        self.business_analytics.set_base_url(base_url)
        self.tasks.set_base_url(base_url)
        self.calendar_events.set_base_url(base_url)
        self.chats.set_base_url(base_url)
        self.posts.set_base_url(base_url)
        self.adaptive_cards.set_base_url(base_url)
        self.notes.set_base_url(base_url)
        self.incoming_webhooks.set_base_url(base_url)
        self.profile.set_base_url(base_url)
        self.conversations.set_base_url(base_url)
        self.compliance_exports.set_base_url(base_url)
        self.teams.set_base_url(base_url)

        return self

    def set_access_token(self, access_token: str):
        """
        Sets the access token for the entire SDK.
        """
        self.webinar_subscriptions.set_access_token(access_token)
        self.historical_webinars.set_access_token(access_token)
        self.historical_recordings.set_access_token(access_token)
        self.registration_management.set_access_token(access_token)
        self.registrants.set_access_token(access_token)
        self.webinars_and_sessions.set_access_token(access_token)
        self.invitees.set_access_token(access_token)
        self.call_recordings.set_access_token(access_token)
        self.greetings.set_access_token(access_token)
        self.user_settings.set_access_token(access_token)
        self.message_store.set_access_token(access_token)
        self.ivr.set_access_token(access_token)
        self.bridge_management.set_access_token(access_token)
        self.meeting_recordings.set_access_token(access_token)
        self.delegation_management.set_access_token(access_token)
        self.meetings_history.set_access_token(access_token)
        self.api_info.set_access_token(access_token)
        self.o_auth_2_0_open_id_connect.set_access_token(access_token)
        self.company.set_access_token(access_token)
        self.devices.set_access_token(access_token)
        self.phone_numbers.set_access_token(access_token)
        self.business_hours.set_access_token(access_token)
        self.custom_fields.set_access_token(access_token)
        self.call_recording_settings.set_access_token(access_token)
        self.call_control.set_access_token(access_token)
        self.sms_templates.set_access_token(access_token)
        self.call_log.set_access_token(access_token)
        self.extensions.set_access_token(access_token)
        self.high_volume_sms.set_access_token(access_token)
        self.call_handling_rules.set_access_token(access_token)
        self.external_contacts.set_access_token(access_token)
        self.call_queues.set_access_token(access_token)
        self.presence.set_access_token(access_token)
        self.automatic_location_updates.set_access_token(access_token)
        self.rcm_meetings_legacy.set_access_token(access_token)
        self.role_management.set_access_token(access_token)
        self.call_monitoring_groups.set_access_token(access_token)
        self.audit_trail.set_access_token(access_token)
        self.message_exports.set_access_token(access_token)
        self.internal_contacts.set_access_token(access_token)
        self.paging_only_groups.set_access_token(access_token)
        self.multi_site.set_access_token(access_token)
        self.video_configuration.set_access_token(access_token)
        self.pager_messages.set_access_token(access_token)
        self.user_permissions.set_access_token(access_token)
        self.call_forwarding.set_access_token(access_token)
        self.fax.set_access_token(access_token)
        self.ring_out.set_access_token(access_token)
        self.site_administration.set_access_token(access_token)
        self.sms.set_access_token(access_token)
        self.features.set_access_token(access_token)
        self.call_blocking.set_access_token(access_token)
        self.subscriptions.set_access_token(access_token)
        self.regional_settings.set_access_token(access_token)
        self.device_sip_registration.set_access_token(access_token)
        self.status.set_access_token(access_token)
        self.text.set_access_token(access_token)
        self.audio.set_access_token(access_token)
        self.insights.set_access_token(access_token)
        self.contents.set_access_token(access_token)
        self.identities.set_access_token(access_token)
        self.scim.set_access_token(access_token)
        self.business_analytics.set_access_token(access_token)
        self.tasks.set_access_token(access_token)
        self.calendar_events.set_access_token(access_token)
        self.chats.set_access_token(access_token)
        self.posts.set_access_token(access_token)
        self.adaptive_cards.set_access_token(access_token)
        self.notes.set_access_token(access_token)
        self.incoming_webhooks.set_access_token(access_token)
        self.profile.set_access_token(access_token)
        self.conversations.set_access_token(access_token)
        self.compliance_exports.set_access_token(access_token)
        self.teams.set_access_token(access_token)

        return self


# c029837e0e474b76bc487506e8799df5e3335891efe4fb02bda7a1441840310c
